unit UnidadAgricultor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, variants, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, dxExEdtr, dxDBTLCl, dxGrClms, QuickRpt, QRCtrls, dxgridmenus;

type
  TformAgricultor = class(TForm)
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton9: TToolButton;
    Tabla: TdxDBGrid;
    actOP: TActionList;
    actEnviarExcel: TAction;
    actMostrarOcultarAutofiltros: TAction;
    actEnviarTodosTexto: TAction;
    actMostrarOcultarSumario: TAction;
    actMostrarOcultarPanelAgrupacion: TAction;
    actEnviarTodosXML: TAction;
    actEnviarHTML: TAction;
    actEnviarPortaPapeles: TAction;
    pmEnvio: TPopupMenu;
    EnviartodosaExcel1: TMenuItem;
    EnviartodosaTexto1: TMenuItem;
    EnviartodosaHTML1: TMenuItem;
    EnviartodosaXML1: TMenuItem;
    N4: TMenuItem;
    Copiaralportapapeles1: TMenuItem;
    dlGuardar: TSaveDialog;
    ActionList1: TActionList;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ActRefrescar: TAction;
    ActCerrar: TAction;
    ActImprimir: TAction;
    ActVisualizar: TAction;
    tc: TQuery;
    dTC: TDataSource;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    actImprimirDatosSobre: TAction;
    LImpresionSobre: TQuickRep;
    TitleBand1: TQRBand;
    LNombre: TQRLabel;
    LDireccion: TQRLabel;
    LCP: TQRLabel;
    LPais: TQRLabel;
    tcNombre: TStringField;
    tcDireccion: TStringField;
    tcCP: TStringField;
    tcPoblacion: TStringField;
    tcWeb: TStringField;
    tcTelefono: TStringField;
    tcFax: TStringField;
    tcNIF: TStringField;
    tcPais: TStringField;
    TablaCodigo: TdxDBGridMaskColumn;
    TablaNombre: TdxDBGridMaskColumn;
    TablaDireccion: TdxDBGridMaskColumn;
    TablaCP: TdxDBGridMaskColumn;
    TablaPoblacion: TdxDBGridMaskColumn;
    TablaWeb: TdxDBGridMaskColumn;
    TablaTelefono: TdxDBGridMaskColumn;
    TablaFax: TdxDBGridMaskColumn;
    TablaNIF: TdxDBGridMaskColumn;
    TablaPais: TdxDBGridMaskColumn;
    tcProvincia: TStringField;
    tcEmail: TStringField;
    tcPersonaContacto: TStringField;
    tcObservacion: TStringField;
    tcCodigoUsuarioAlta: TStringField;
    tcFechaAlta: TDateField;
    tcHoraAlta: TTimeField;
    TablaProvincia: TdxDBGridMaskColumn;
    TablaEmail: TdxDBGridMaskColumn;
    TablaPersonaContacto: TdxDBGridMaskColumn;
    TablaObservacion: TdxDBGridMaskColumn;
    TablaCodigoUsuarioAlta: TdxDBGridMaskColumn;
    TablaFechaAlta: TdxDBGridDateColumn;
    TablaHoraAlta: TdxDBGridTimeColumn;
    tcTipo: TStringField;
    TablaTipo: TdxDBGridMaskColumn;
    tcCodigo: TStringField;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActVisualizarExecute(Sender: TObject);
    procedure actEnviarExcelExecute(Sender: TObject);
    procedure actEnviarHTMLExecute(Sender: TObject);
    procedure actEnviarPortaPapelesExecute(Sender: TObject);
    procedure actEnviarTodosTextoExecute(Sender: TObject);
    procedure actEnviarTodosXMLExecute(Sender: TObject);
    procedure actMostrarOcultarAutofiltrosExecute(Sender: TObject);
    procedure actMostrarOcultarPanelAgrupacionExecute(Sender: TObject);
    procedure actMostrarOcultarSumarioExecute(Sender: TObject);
    procedure TablaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure llenarGrid();
    procedure actImprimirDatosSobreExecute(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formAgricultor: TformAgricultor;
const
  ventana = 'Proveedor';
  ventanas = 'Proveedores';

implementation

uses UnidadMenuPrincipal, UnidadImprimir, UnidadModuloDatos,
  UnidadProcedimientos, UnidadGAgricultor;
{$R *.DFM}

var
  tTabla : TTable;

procedure TformAgricultor.llenarGrid();
begin
  tc.Close;
  tc.SQL.Clear;
  tc.SQL.Add('SELECT * FROM ' + vtTablaAgricultor);
  tc.Open;
end;

  
procedure TformAgricultor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
   tc.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TformAgricultor.FormShow(Sender: TObject);
begin
  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
  screen.cursor := crdefault;
end;

procedure TformAgricultor.ActNuevoExecute(Sender: TObject);
begin
  if comprobarPermisos ('altas', vtTipoUsuario, vtTablaAgricultor) then
  begin
    vtAccion := 'nuevo';
    application.createform(tformGAgricultor, formGAgricultor);
    formGAgricultor.ShowModal;
    ActRefrescarExecute(nil);
  end;
end;

procedure TformAgricultor.ActEliminarExecute(Sender: TObject);
var
  nombre : string;
  eliminar : boolean;
begin
  if tc.RecordCount <= 0 then
    MessageDlg ('No hay datos para eliminar.', mtWarning, [mbok], 0)
  else
  begin
    if comprobarPermisos('bajas', vtTipoUsuario, vtTablaAgricultor) then
    begin
      tTabla.Active := true;
      if tTabla.locate('Codigo', tcCodigo.value, []) then
      begin
        if not varisnull(tcNombre.Value) then
          nombre := tcNombre.Value
        else
          nombre := null;
        eliminar := true;
        with datos.TC do
        begin
          //comprobamos integridad referencial: PARCELA
          Close;
          SQL.Clear;
          SQL.Add('SELECT count(CodigoAgricultor) NumeroT');
          SQL.Add('FROM ' + vtTablaParcela);
          SQL.Add('WHERE CodigoAgricultor = :pCodigo');
          ParamByName('pCodigo').DataType := ftString;
          ParamByName('pCodigo').Value := tcCodigo.Value;
          Open;
          if FieldByName('NumeroT').value > 0 then
          begin
            eliminar := false;
            messagedlg ('El ' + ventana + ' [' + nombre + '] no se puede ' +
                'eliminar ya que existe en Parcelas.', mtWarning, [mbok], 0);
          end;
          if eliminar then
          begin
            if messagedlg ('Est seguro que desea eliminar el ' + ventana + ': ' +
                nombre + '?', mtConfirmation, [mbyes, mbno], 0) = mryes then
            begin
              try
                ttabla.Delete;
                ActRefrescarExecute(nil);
              except
                raise;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TformAgricultor.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TformAgricultor.ActModificarExecute(Sender: TObject);
begin
  if tc.RecordCount <= 0 then
    messagedlg ('No hay datos para modificar.', mtInformation, [mbok], 0)
  else
  begin
    if comprobarPermisos ('modificacin', vtTipoUsuario, vtTablaAgricultor) then
    begin
      if not varisnull(tcCodigo.value) then
      begin
        vtAccion := 'modificar';
        ttabla.Active := true;
        ttabla.locate ('Codigo', tcCodigo.Value, []);
        ttabla.edit;
        application.createform(TformGAgricultor, formGAgricultor);
        formGAgricultor.ShowModal;
        ActRefrescarExecute(nil);
      end
      else
        messagedlg ('Atencin, el ' + ventana + ' actual no tiene cdigo, ' +
            'elimnelo antes de continuar.', mtError, [mbok], 0);
    end;
  end;
end;

procedure TformAgricultor.TablaDblClick(Sender: TObject);
begin
  if ActModificar.Enabled = true then
    ActModificarExecute(nil);
end;

procedure TformAgricultor.ActRefrescarExecute(Sender: TObject);
begin
  llenarGrid;
end;

procedure TformAgricultor.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TformAgricultor.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TformAgricultor.ActImprimirExecute(Sender: TObject);
begin
  if tc.RecordCount <= 0 then
    messagedlg ('No hay datos para imprimir.', mtInformation, [mbok], 0)
  else
  begin
    if comprobarPermisos ('imprimir', vtTipoUsuario, vtTablaAgricultor) then
    begin
      application.createform(tformImprimir, formImprimir);
      formimprimir.Tag := vtNumAgricultor;
      formImprimir.showmodal;
    end;
  end;
end;

procedure TformAgricultor.ActVisualizarExecute(Sender: TObject);
begin
  if tc.RecordCount <= 0 then
    messagedlg ('No hay datos para mostrar.', mtInformation, [mbok], 0)
  else
  begin
    if comprobarPermisos ('zoom', vtTipoUsuario, vtTablaAgricultor) then
    begin
      vtAccion := 'zoom';
      vtCodigo := tcCodigo.value;
      application.createform(TformGAgricultor, formGAgricultor);
      formGAgricultor.ShowModal;
    end;
  end;
end;

procedure TformAgricultor.actEnviarExcelExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros Excel (*.xls)|*.xls|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a Excel';
  dlGuardar.DefaultExt := 'xls';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToXLS(dlguardar.FileName,true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;

procedure TformAgricultor.actEnviarHTMLExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros HTML (*.html)|*.html|Ficheros HTML (*.htm)|*.htm|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a HTML';
  dlGuardar.DefaultExt := 'html';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToHTML(dlguardar.filename, true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;


procedure TformAgricultor.actEnviarPortaPapelesExecute(Sender: TObject);
begin
  tabla.CopyAllToClipboard;
  MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
end;

procedure TformAgricultor.actEnviarTodosTextoExecute(Sender: TObject);
var
  separador : string;
begin
  dlguardar.Filter := 'Ficheros de texto (*.txt)|*.txt|Ficheros Word (*.doc)|*.doc|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a texto sin formato';
  dlguardar.FileName := ventanas;
  dlGuardar.DefaultExt := 'txt';
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    separador := InputBox('Separador para campos...', 'Introduzca un carcter que ser el separador de campos:', '#');
    if Length(separador) > 1 then
      MessageDlg('Slo debe seleccionar un carcter. Se anular el proceso.', mtWarning, [mbok], 0)
    else
    begin
      tabla.SaveToText(dlguardar.filename, true, #9, separador, separador);
      MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
    end;  
  end;    
end;

procedure TformAgricultor.actEnviarTodosXMLExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros XML (*.xml)|*.xml|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a XML';
  dlGuardar.DefaultExt := 'xml';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToXML(dlguardar.FileName,true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;

procedure TformAgricultor.actMostrarOcultarAutofiltrosExecute(
  Sender: TObject);
begin
  tabla.Filter.Active := not tabla.Filter.Active;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
end;

procedure TformAgricultor.actMostrarOcultarPanelAgrupacionExecute(
  Sender: TObject);
begin
  tabla.ShowGroupPanel := not tabla.ShowGroupPanel;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
end;

procedure TformAgricultor.actMostrarOcultarSumarioExecute(Sender: TObject);
begin
  tabla.ShowSummaryFooter := not tabla.ShowSummaryFooter;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
end;

procedure TformAgricultor.TablaMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button <> mbRight) or (Shift <> []) then
    Exit;
  TdxDBGridPopupMenuManager.Instance.ShowGridPopupMenu(Sender as TdxDBGrid);
end;

procedure TformAgricultor.FormCreate(Sender: TObject);
begin
  tTabla := datos.tAgricultor;
  llenarGrid(); 
end;

procedure TformAgricultor.actImprimirDatosSobreExecute(Sender: TObject);
var
  cp, ciudad, provincia, pais : string;
begin
  if messagedlg ('Se va a imprimir la direccin del ' + ventana + ': ' + 
      chr(13) + chr(13) + tc.fieldbyname('Nombre').Value +
      chr(13) + chr(13) + '   Inserte un sobre en la impresora y pulse Aceptar.',
      mtinformation, mbOKCancel,0) = mrok then
  begin
    if not varisnull(tc.fieldbyname('Nombre').value) then
      LNombre.Caption := tc.fieldbyname('Nombre').value;
    if not varisnull(tc.fieldbyname('Direccion').value) then
      LDireccion.Caption := tc.fieldbyname('Direccion').value;
    if not varisnull(tc.fieldbyname('CP').value) then
      cp := tc.fieldbyname('CP').value
    else
      cp := '';
    if not varisnull (tc.fieldbyname('Poblacion').value) then
      ciudad := tc.fieldbyname('Poblacion').value
    else
      ciudad := '';
    if not varisnull (tc.fieldbyname('Provincia').value) then
      provincia := tc.fieldbyname('Provincia').value
    else
      provincia := '';
    if not varisnull (tc.fieldbyname('Pais').value) then
      pais := tc.fieldbyname('Pais').value
    else
      pais := '';
    LCP.Caption := cp + '  '  + ciudad;
    LPais.Caption := provincia + '   (' + pais + ')';
    limpresionsobre.Print;
  end;
end;

end.
