unit UnidadFormulacion;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, variants, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, dxExEdtr, dxDBTLCl, dxGrClms, QuickRpt, QRCtrls, dxgridmenus;

type
  TformFormulacion = class(TForm)
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton9: TToolButton;
    Tabla: TdxDBGrid;
    actOP: TActionList;
    actEnviarExcel: TAction;
    actMostrarOcultarAutofiltros: TAction;
    actEnviarTodosTexto: TAction;
    actMostrarOcultarSumario: TAction;
    actMostrarOcultarPanelAgrupacion: TAction;
    actEnviarTodosXML: TAction;
    actEnviarHTML: TAction;
    actEnviarPortaPapeles: TAction;
    pmEnvio: TPopupMenu;
    EnviartodosaExcel1: TMenuItem;
    EnviartodosaTexto1: TMenuItem;
    EnviartodosaHTML1: TMenuItem;
    EnviartodosaXML1: TMenuItem;
    N4: TMenuItem;
    Copiaralportapapeles1: TMenuItem;
    dlGuardar: TSaveDialog;
    ActionList1: TActionList;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ActRefrescar: TAction;
    ActCerrar: TAction;
    ActImprimir: TAction;
    ActVisualizar: TAction;
    tc: TQuery;
    dTC: TDataSource;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    actImprimirDatosSobre: TAction;
    TablaCodigo: TdxDBGridMaskColumn;
    TablaNombre: TdxDBGridMaskColumn;
    TablaCodigoUsuarioAlta: TdxDBGridMaskColumn;
    TablaFechaAlta: TdxDBGridDateColumn;
    TablaHoraAlta: TdxDBGridTimeColumn;
    tcCodigo: TStringField;
    tcNombre: TStringField;
    tcCodigoUsuarioAlta: TStringField;
    tcFechaAlta: TDateField;
    tcHoraAlta: TTimeField;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActVisualizarExecute(Sender: TObject);
    procedure actEnviarExcelExecute(Sender: TObject);
    procedure actEnviarHTMLExecute(Sender: TObject);
    procedure actEnviarPortaPapelesExecute(Sender: TObject);
    procedure actEnviarTodosTextoExecute(Sender: TObject);
    procedure actEnviarTodosXMLExecute(Sender: TObject);
    procedure actMostrarOcultarAutofiltrosExecute(Sender: TObject);
    procedure actMostrarOcultarPanelAgrupacionExecute(Sender: TObject);
    procedure actMostrarOcultarSumarioExecute(Sender: TObject);
    procedure TablaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure llenarGrid();


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formFormulacion: TformFormulacion;
const
  ventana = 'Formulacion';
  ventanas = 'Formulaciones';

implementation

uses UnidadMenuPrincipal, UnidadImprimir, UnidadModuloDatos,
  UnidadProcedimientos, UnidadGFormulacion;
{$R *.DFM}

var
  tTabla : TTable;

procedure TformFormulacion.llenarGrid();
begin
  tc.Close;
  tc.SQL.Clear;
  tc.SQL.Add('SELECT * FROM ' + vtTablaFormulacion);
  tc.Open;
end;

  
procedure TformFormulacion.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
   tc.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TformFormulacion.FormShow(Sender: TObject);
begin
  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
  screen.cursor := crdefault;
end;

procedure TformFormulacion.ActNuevoExecute(Sender: TObject);
begin
  if comprobarPermisos ('altas', vtTipoUsuario, vtTablaFormulacion) then
  begin
    vtAccion := 'nuevo';
    application.createform(tformGFormulacion, formGFormulacion);
    formGFormulacion.ShowModal;
    ActRefrescarExecute(nil);
  end;
end;

procedure TformFormulacion.ActEliminarExecute(Sender: TObject);
var
  nombre : string;
  eliminar : boolean;
begin
  if tc.RecordCount <= 0 then
    MessageDlg ('No hay datos para eliminar.', mtWarning, [mbok], 0)
  else
  begin
    if comprobarPermisos('bajas', vtTipoUsuario, vtTablaFormulacion) then
    begin
      tTabla.Active := true;
      if tTabla.locate('Codigo', tcCodigo.value, []) then
      begin
        if not varisnull(tcNombre.Value) then
          nombre := tcNombre.Value
        else
          nombre := null;

        //comprobamos que no est protegido
        if tcCodigo.Value = vtCodigoFormulacion then
        begin
          MessageDlg('Este registro no se puede eliminar. Se utiliza para uso del sistema.', mtInformation, [mbok], 0);
          exit;
        end;

        eliminar := true;
        with datos.TC do
        begin
          //comprobamos integridad referencial: Productos
          Close;
          SQL.Clear;
          SQL.Add('SELECT count(CodigoFormulacion) NumeroT');
          SQL.Add('FROM ' + vtTablaProducto);
          SQL.Add('WHERE CodigoFormulacion = :pCodigo');
          ParamByName('pCodigo').DataType := ftString;
          ParamByName('pCodigo').Value := tcCodigo.Value;
          Open;
          if FieldByName('NumeroT').value > 0 then
          begin
            Close;
            eliminar := false;
            messagedlg ('La ' + ventana + ' [' + nombre + '] no se puede ' +
                'eliminar ya que existe en Productos.', mtWarning, [mbok], 0);
          end;
          if eliminar then
          begin
            if messagedlg ('Est seguro que desea eliminar la ' + ventana + ': ' +
                nombre + '?', mtConfirmation, [mbyes, mbno], 0) = mryes then
            begin
              try
                ttabla.Delete;
                ActRefrescarExecute(nil);
              except
                raise;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TformFormulacion.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TformFormulacion.ActModificarExecute(Sender: TObject);
begin
  if tc.RecordCount <= 0 then
    messagedlg ('No hay datos para modificar.', mtInformation, [mbok], 0)
  else
  begin
    if comprobarPermisos ('modificacin', vtTipoUsuario, vtTablaFormulacion) then
    begin
      if not varisnull(tcCodigo.value) then
      begin
        if tcCodigo.value = '999999' then
        begin
          MessageDlg('Este registro no se puede modificar. Se utiliza para uso del sistema.', mtInformation, [mbok], 0);
          exit;
        end;                   
        vtAccion := 'modificar';
        ttabla.Active := true;
        ttabla.locate ('Codigo', tcCodigo.Value, []);
        ttabla.edit;
        application.createform(TformGFormulacion, formGFormulacion);
        formGFormulacion.ShowModal;
        ActRefrescarExecute(nil);
      end
      else
        messagedlg ('Atencin, el ' + ventana + ' actual no tiene cdigo, ' +
            'elimnelo antes de continuar.', mtError, [mbok], 0);
    end;
  end;
end;

procedure TformFormulacion.TablaDblClick(Sender: TObject);
begin
  if ActModificar.Enabled = true then
    ActModificarExecute(nil);
end;

procedure TformFormulacion.ActRefrescarExecute(Sender: TObject);
begin
  llenarGrid;
end;

procedure TformFormulacion.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TformFormulacion.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TformFormulacion.ActImprimirExecute(Sender: TObject);
begin
  if tc.RecordCount <= 0 then
    messagedlg ('No hay datos para imprimir.', mtInformation, [mbok], 0)
  else
  begin
    if comprobarPermisos ('imprimir', vtTipoUsuario, vtTablaFormulacion) then
    begin
      application.createform(tformImprimir, formImprimir);
      formimprimir.Tag := vtNumFormulacion;
      formImprimir.showmodal;
    end;
  end;
end;

procedure TformFormulacion.ActVisualizarExecute(Sender: TObject);
begin
  if tc.RecordCount <= 0 then
    messagedlg ('No hay datos para mostrar.', mtInformation, [mbok], 0)
  else
  begin
    if comprobarPermisos ('zoom', vtTipoUsuario, vtTablaFormulacion) then
    begin
      vtAccion := 'zoom';
      vtCodigo := tcCodigo.value;
      application.createform(TformGFormulacion, formGFormulacion);
      formGFormulacion.ShowModal;
    end;
  end;
end;

procedure TformFormulacion.actEnviarExcelExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros Excel (*.xls)|*.xls|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a Excel';
  dlGuardar.DefaultExt := 'xls';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToXLS(dlguardar.FileName,true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;

procedure TformFormulacion.actEnviarHTMLExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros HTML (*.html)|*.html|Ficheros HTML (*.htm)|*.htm|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a HTML';
  dlGuardar.DefaultExt := 'html';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToHTML(dlguardar.filename, true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;


procedure TformFormulacion.actEnviarPortaPapelesExecute(Sender: TObject);
begin
  tabla.CopyAllToClipboard;
  MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
end;

procedure TformFormulacion.actEnviarTodosTextoExecute(Sender: TObject);
var
  separador : string;
begin
  dlguardar.Filter := 'Ficheros de texto (*.txt)|*.txt|Ficheros Word (*.doc)|*.doc|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a texto sin formato';
  dlguardar.FileName := ventanas;
  dlGuardar.DefaultExt := 'txt';
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    separador := InputBox('Separador para campos...', 'Introduzca un carcter que ser el separador de campos:', '#');
    if Length(separador) > 1 then
      MessageDlg('Slo debe seleccionar un carcter. Se anular el proceso.', mtWarning, [mbok], 0)
    else
    begin
      tabla.SaveToText(dlguardar.filename, true, #9, separador, separador);
      MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
    end;  
  end;    
end;

procedure TformFormulacion.actEnviarTodosXMLExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros XML (*.xml)|*.xml|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a XML';
  dlGuardar.DefaultExt := 'xml';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToXML(dlguardar.FileName,true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;

procedure TformFormulacion.actMostrarOcultarAutofiltrosExecute(
  Sender: TObject);
begin
  tabla.Filter.Active := not tabla.Filter.Active;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
end;

procedure TformFormulacion.actMostrarOcultarPanelAgrupacionExecute(
  Sender: TObject);
begin
  tabla.ShowGroupPanel := not tabla.ShowGroupPanel;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
end;

procedure TformFormulacion.actMostrarOcultarSumarioExecute(Sender: TObject);
begin
  tabla.ShowSummaryFooter := not tabla.ShowSummaryFooter;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
end;

procedure TformFormulacion.TablaMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button <> mbRight) or (Shift <> []) then
    Exit;
  TdxDBGridPopupMenuManager.Instance.ShowGridPopupMenu(Sender as TdxDBGrid);
end;

procedure TformFormulacion.FormCreate(Sender: TObject);
begin
  tTabla := datos.tFormulacion;
  llenarGrid(); 
end;

end.
