unit UnidadGContador;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, Mask, forms, ComCtrls,
  variants, windows;

type
  TformContadorG = class(TForm)
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    Label1: TLabel;
    txtAnio: TDBEdit;
    Label2: TLabel;
    txtTabla: TDBEdit;
    Label3: TLabel;
    txtContador: TDBEdit;
    Label4: TLabel;
    txtNota: TDBEdit;
    opActivo: TDBCheckBox;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure TxtCPChange(Sender: TObject);
    procedure TxtTelefonoChange(Sender: TObject);
    procedure DBEdit3KeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    function cDuplicado (nombre : string) : boolean;
    procedure txtAnioExit(Sender: TObject);
    procedure txtAnioEnter(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formContadorG: TformContadorG;
const
  ventana = 'Contador';
  ventanas = 'Contadores';

implementation


uses UnidadModuloDatos, UnidadProcedimientos;

var
  tTabla : TTable;
{$R *.DFM}


//comprobar nombre duplicado
function TformContadorG.cDuplicado (nombre : string) : boolean;
begin
  with datos.tc do
  begin
    Close;
    SQL.Clear;
    SQL.Add('SELECT COUNT(Codigo) Contador');
    SQL.Add('FROM ' + vtTablaContador);
    SQL.Add('WHERE UPPER(nombre) = :pNombre');
    ParamByName('pNombre').DataType := ftString;
    ParamByName('pNombre').Value := AnsiUpperCase(nombre);
    Open;
    if FieldByName('Contador').value > 0 then
    begin
      Close;
      cDuplicado := true;
    end
    else
    begin
      Close;
      cDuplicado := false;
    end;
  end;
end;


procedure TformContadorG.BCancelarClick(Sender: TObject);
begin
  try
    ttabla.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TformContadorG.BAceptarClick(Sender: TObject);
begin
{  if txtNombre.Text = '' then
  begin
    MessageDlg ('El campo Nombre debe tener un valor', mtWarning, [mbok], 0);
    TxtNombre.setfocus;
    exit;
  end;}
  //si es una modificacin y se modifica el nombre, comprobar duplicidad
{  if vtAccion = 'modificar' then
  begin
    if txtNombre.Text = valorAnterior then
    begin
      if cDuplicado(txtNombre.Text) then
      begin
        MessageDlg('El ' + ventana + ' [' + txtNombre.Text + '] ya existe.', mtWarning, [mbok], 0);
        txtNombre.SelectAll;
        txtnombre.SetFocus;
        exit;
      end;
    end;
  end;}
  //si es nuevo comprobar duplicidad
  {if vtAccion = 'nuevo' then
  begin
    if cDuplicado(txtNombre.Text) then
    begin
      MessageDlg('El ' + ventana + ' [' + txtNombre.Text + '] ya existe.', mtWarning, [mbok], 0);
      txtNombre.SelectAll;
      txtnombre.SetFocus;
      exit;
    end;
  end;}
  if ttabla.State  in [dsinsert, dsedit] then
  begin
    try
      ttabla.Post; //validar
    except
      //txtNombre.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TformContadorG.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ttabla.Close;
  action := cafree;
end;

procedure TformContadorG.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformContadorG.FormShow(Sender: TObject);
begin
  tTabla := datos.tContador;
  if vtAccion = 'nuevo' then
  begin
    caption := 'Aadir ' + ventana + '...';;
    txtTabla.SetFocus;
    tTabla.Active := true;
    tTabla.Insert;
  end;

  if vtAccion = 'modificar' then
  begin
   // txtcodigo.Enabled := false;
    caption := 'Modificacin de ' + ventana + '...';
    txtTabla.SetFocus;
    tTabla.Edit;
  end;

  if vtAccion = 'zoom' then
  begin
    tTabla.Active := true;
    tTabla.locate ('Tabla', vtCodigo, []);
    caption := 'Visualizacin de ' + ventana + '...';
    baceptar.Visible := false;
    bcancelar.SetFocus;
  end;
end;

procedure TformContadorG.TxtCPChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txtcp.text) = 5 then
      txttelefono.setfocus;
  end;}
end;

procedure TformContadorG.TxtTelefonoChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txttelefono.text) = 9 then
      opIVA.setfocus;
  end;}
end;

procedure TformContadorG.DBEdit3KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = '.' then
    key := ',';
end;

procedure TformContadorG.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //cambiar el foco con las teclas de cursor
  if (Key in [VK_UP, VK_DOWN]) and
      Not (ActiveControl is TDBComboBox) and not (ActiveControl is TDBMemo) then
  begin
    if Key = VK_UP then
      Perform(WM_NEXTDLGCTL, 1, 0)
    else
      Perform(WM_NEXTDLGCTL, 0, 0);
    Key := 0;
  end;
end;

procedure TformContadorG.txtAnioExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformContadorG.txtAnioEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

end.
