unit UnidadGDistribuidor;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, Mask, forms, ComCtrls,
  variants, windows, dxExEdtr, dxCntner, dxTL, dxDBCtrl, dxDBGrid,
  dxDBTLCl, dxGrClms;

type
  TformGDistribuidor = class(TForm)
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    tab: TPageControl;
    tabGeneral: TTabSheet;
    tabContacto: TTabSheet;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    txtTelefono: TDBEdit;
    Label5: TLabel;
    txtFax: TDBEdit;
    Label7: TLabel;
    txtContacto: TDBEdit;
    Label8: TLabel;
    txtWeb: TDBEdit;
    Label9: TLabel;
    txtEMail: TDBEdit;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    txtNombre: TDBEdit;
    txtCodigo: TDBEdit;
    BGCodigoAuto: TSpeedButton;
    lCodigo: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    txtDNI: TDBEdit;
    GroupBox2: TGroupBox;
    Label10: TLabel;
    Label12: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    txtDireccion: TDBEdit;
    txtPoblacion: TDBEdit;
    txtProvincia: TDBEdit;
    txtPais: TDBEdit;
    txtCP: TDBEdit;
    txtObservacion: TDBMemo;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure TxtCPChange(Sender: TObject);
    procedure TxtTelefonoChange(Sender: TObject);
    procedure DBEdit3KeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    function generarCodigoAuto () : string;
    function cDuplicado (nombre : string) : boolean;

    procedure BGCodigoAutoClick(Sender: TObject);
    procedure txtNombreEnter(Sender: TObject);
    procedure txtNombreExit(Sender: TObject);
    procedure txtCodigoEnter(Sender: TObject);
    procedure txtDNIEnter(Sender: TObject);
    procedure txtCapitalEnter(Sender: TObject);
    procedure txtObservacionEnter(Sender: TObject);
    procedure txtContactoEnter(Sender: TObject);
    procedure txtTelefonoEnter(Sender: TObject);
    procedure txtTelefono2Enter(Sender: TObject);
    procedure txtFax2Enter(Sender: TObject);
    procedure txtTelefono3Enter(Sender: TObject);
    procedure txtFaxEnter(Sender: TObject);
    procedure txtWebEnter(Sender: TObject);
    procedure txtEMailEnter(Sender: TObject);
    procedure txtDireccionEnter(Sender: TObject);
    procedure txtCPEnter(Sender: TObject);
    procedure txtPoblacionEnter(Sender: TObject);
    procedure txtProvinciaEnter(Sender: TObject);
    procedure txtPaisEnter(Sender: TObject);
    procedure txtEntidadEnter(Sender: TObject);
    procedure txtOficinaEnter(Sender: TObject);
    procedure txtDCEnter(Sender: TObject);
    procedure txtIBANEnter(Sender: TObject);
    procedure txtCodigoExit(Sender: TObject);
    procedure txtDNIExit(Sender: TObject);
    procedure txtCapitalExit(Sender: TObject);
    procedure txtObservacionExit(Sender: TObject);
    procedure txtContactoExit(Sender: TObject);
    procedure txtTelefono2Exit(Sender: TObject);
    procedure txtTelefonoExit(Sender: TObject);
    procedure txtTelefono3Exit(Sender: TObject);
    procedure txtFaxExit(Sender: TObject);
    procedure txtWebExit(Sender: TObject);
    procedure txtFax2Exit(Sender: TObject);
    procedure txtEMailExit(Sender: TObject);
    procedure txtDireccionExit(Sender: TObject);
    procedure txtEntidadExit(Sender: TObject);
    procedure txtOficinaExit(Sender: TObject);
    procedure txtDCExit(Sender: TObject);
    procedure txtIBANExit(Sender: TObject);
    procedure txtPorcentajeBeneficioEnter(Sender: TObject);
    procedure txtPorcentajeBeneficioExit(Sender: TObject);
    procedure txtPorcentajeBeneficioKeyPress(Sender: TObject;
      var Key: Char);
    procedure txtCapitalKeyPress(Sender: TObject; var Key: Char);
    procedure txtPorcentajeIVAEnter(Sender: TObject);
    procedure txtPorcentajeIVAExit(Sender: TObject);
    procedure txtPorcentajeIVAKeyPress(Sender: TObject; var Key: Char);
    procedure txtCPExit(Sender: TObject);
    procedure txtPoblacionExit(Sender: TObject);
    procedure txtProvinciaExit(Sender: TObject);
    procedure txtPaisExit(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formGDistribuidor: TformGDistribuidor;
const
  ventana = 'Distribuidor';
  ventanas = 'Distribuidores';

implementation


uses UnidadModuloDatos, UnidadProcedimientos, UnidadSeleccion;

var
  tTabla : TTable;
  valorAnterior : string; //para modificacin de Nombre
{$R *.DFM}

//Genera el cdigo automticamente
function TformGDistribuidor.generarCodigoAuto () : string;
var
  vano, vmes, vdia : word;
  contador : double;
begin
  DecodeDate(date, vano, vmes, vdia);
  with datos.tc do
  begin
    Close;
    SQL.Clear;  //obtenemos el contador de la tabla contadores
    SQL.Add('SELECT Contador');
    SQL.Add('FROM ' + vtTablaContador);
    SQL.Add('WHERE tabla = :pTabla');
    //SQL.Add('WHERE tabla = :pTabla AND anio = :pAno');
    //ParamByName('pAno').DataType := ftFloat;
    //ParamByName('pAno').Value := vano;
    ParamByName('pTabla').DataType := ftString;
    ParamByName('pTabla').Value := vtTablaDistribuidor;
    Open;
    if FieldByName('Contador').value <> null then
    begin
      try
        contador := FieldByName('Contador').Value + 1;
        generarCodigoAuto := llenarCadena(floattostr(contador),4,'0', false);
        //Incrementamos el contador de la tabla contadores
        Close;
        SQL.Clear;
        SQL.Add('UPDATE ' + vtTablaContador +
            ' SET Contador = :pContador, CodigoUsuarioAlta = "'
            + vtCodigoUsuario + '" WHERE tabla = :pTabla');
             //+ vtCodigoUsuario + '" WHERE tabla = :pTabla AND anio = :pAno');
        //ParamByName('pAno').DataType := ftFloat;
        //ParamByName('pAno').Value := vano;
        ParamByName('pContador').DataType := ftFloat;
        ParamByName('pContador').Value := contador;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').Value := vtTablaDistribuidor;
        ExecSQL;
        close;
      except
        Close;
        generarCodigoAuto := '1';
        MessageDlg ('El cdigo no ha podido generarse automticamente.', mtError, [mbOK], 0);
        txtCodigo.Enabled := true;
        txtCodigo.Visible := true;
        txtCodigo.SetFocus;
      end;
    end
    else  //si no existe el registro de contador para la tabla actual, lo creamos
    begin
      try
        Close;
        SQL.Clear;
        SQL.Add('INSERT INTO ' + vtTablaContador +
            ' (Anio, Tabla, Contador, Nota, Activo, CodigoUsuarioAlta) ' +
            ' VALUES (:pAno, :pTabla, 1, "Aadido automticamente", True, "' +
            vtCodigoUsuario + '")');
        ParamByName('pAno').DataType := ftFloat;
        ParamByName('pAno').Value := vano;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').Value := vtTablaDistribuidor;
        ExecSQL;
        generarCodigoAuto := '0001';
        Close;
      except
        Close;
        MessageDlg ('El contador no se ha guardado correctamente.', mtError, [mbOK], 0);
      end;
    end;
  end;
end;

//comprobar nombre duplicado
function TformGDistribuidor.cDuplicado (nombre : string) : boolean;
begin
  with datos.tc do
  begin
    Close;
    SQL.Clear;
    SQL.Add('SELECT COUNT(Codigo) Contador');
    SQL.Add('FROM ' + vtTablaDistribuidor);
    SQL.Add('WHERE UPPER(nombre) = :pNombre');
    ParamByName('pNombre').DataType := ftString;
    ParamByName('pNombre').Value := AnsiUpperCase(nombre);
    Open;
    if FieldByName('Contador').value > 0 then
    begin
      Close;
      cDuplicado := true;
    end
    else
    begin
      Close;
      cDuplicado := false;
    end;
  end;
end;


procedure TformGDistribuidor.BCancelarClick(Sender: TObject);
begin
  try
    ttabla.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TformGDistribuidor.BAceptarClick(Sender: TObject);
begin
  //comprobamos si es protegido
  if txtCodigo.Text = '9999' then
  begin
    tabGeneral.Show;
    MessageDlg ('El cdigo "9999" est reservado al sistema. Utilice otro.', mtWarning, [mbok], 0);
    txtCodigo.Visible := true;
    txtCodigo.Enabled := true;
    TxtCodigo.setfocus;
    exit;
  end;

  //si el cdigo no se genera automticamente comprobar que est introducido
  if txtCodigo.Visible then
  begin
    if txtCodigo.Text = '' then
    begin
      tabGeneral.Show;
      MessageDlg ('El campo Cdigo debe tener un valor.', mtWarning, [mbok], 0);
      TxtCodigo.setfocus;
      exit;
    end;
  end;
  if txtNombre.Text = '' then
  begin
    tabGeneral.Show;
    MessageDlg ('El campo Nombre debe tener un valor.', mtWarning, [mbok], 0);
    TxtNombre.setfocus;
    exit;
  end;
  //si es una modificacin y se modifica el nombre, comprobar duplicidad
  if vtAccion = 'modificar' then
  begin
    if AnsiUpperCase(txtNombre.Text) <> AnsiUpperCase(valorAnterior) then //s se ha modificado
    begin
      if cDuplicado(txtNombre.Text) then
      begin
        tabGeneral.Show;
        MessageDlg('El ' + ventana + ' [' + txtNombre.Text + '] ya existe.', mtWarning, [mbok], 0);
        txtNombre.SelectAll;
        txtnombre.SetFocus;
        exit;
      end;
    end;
  end;
  //si es nuevo comprobar duplicidad
  if vtAccion = 'nuevo' then
  begin
    if cDuplicado(txtNombre.Text) then
    begin
      tabGeneral.Show;
      MessageDlg('El ' + ventana + ' [' + txtNombre.Text + '] ya existe.', mtWarning, [mbok], 0);
      txtNombre.SelectAll;
      txtnombre.SetFocus;
      exit;
    end;
  end;

  if ttabla.State  in [dsinsert, dsedit] then
  begin
    //Generar cdigo automticamente si es una insercin
    if (vtGCADistribuidor) and (vtAccion = 'nuevo') then
      txtcodigo.Text := generarCodigoAuto;
    tTabla.FieldByName('CodigoUsuarioAlta').Value := vtCodigoUsuario;
    tTabla.FieldByName('FechaAlta').Value := Date;
    tTabla.FieldByName('HoraAlta').Value := Time;
    try
      ttabla.Post; //validar
    except
      tabGeneral.Show;
      txtNombre.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TformGDistribuidor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ttabla.Close;
  action := cafree;
end;

procedure TformGDistribuidor.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformGDistribuidor.FormShow(Sender: TObject);
begin
  tabGeneral.Show;
  tTabla := datos.TDistribuidor;
  if vtAccion = 'nuevo' then
  begin
    caption := 'Aadir ' + ventana + '...';
    //Si no est activado generar cdigo automtico
    if (vtGCADistribuidor) = false then
    begin
      txtCodigo.Visible := true;
      txtCodigo.SetFocus;
      BGCodigoAuto.Visible := true;
    end
    else
      txtNombre.SetFocus;
    tTabla.Active := true;
    tTabla.Insert;
  end;

  if vtAccion = 'modificar' then
  begin
    txtcodigo.Enabled := false;
    BGCodigoAuto.Enabled := false;
    caption := 'Modificacin de ' + ventana + '...';
    txtNombre.SetFocus;
    valorAnterior := ttabla.fieldbyname('Nombre').Value;
    tTabla.Edit;
  end;

  if vtAccion = 'zoom' then
  begin
    tTabla.Active := true;
    tTabla.locate ('Codigo', vtCodigo, []);
    caption := 'Visualizacin de ' + ventana + '...';
    txtcodigo.Enabled := false;
    BGCodigoAuto.Enabled := false;
    txtNombre.Enabled := false;
    baceptar.Visible := false;
    bcancelar.SetFocus;
  end;
end;

procedure TformGDistribuidor.TxtCPChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txtcp.text) = 5 then
      txttelefono.setfocus;
  end;}
end;

procedure TformGDistribuidor.TxtTelefonoChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txttelefono.text) = 9 then
      opIVA.setfocus;
  end;}
end;

procedure TformGDistribuidor.DBEdit3KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = '.' then
    key := ',';
end;

procedure TformGDistribuidor.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //cambiar el foco con las teclas de cursor
  if (Key in [VK_UP, VK_DOWN]) and
      Not (ActiveControl is TDBComboBox) and not (ActiveControl is TDBMemo) then
  begin
    if Key = VK_UP then
      Perform(WM_NEXTDLGCTL, 1, 0)
    else
      Perform(WM_NEXTDLGCTL, 0, 0);
    Key := 0;
  end;
end;

procedure TformGDistribuidor.BGCodigoAutoClick(Sender: TObject);
begin
  txtCodigo.Text := generarCodigoAuto;
end;

procedure TformGDistribuidor.txtNombreEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtNombreExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtCodigoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtDNIEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtCapitalEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtObservacionEnter(Sender: TObject);
begin
  TDBMemo(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtContactoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtTelefonoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtTelefono2Enter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtFax2Enter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtTelefono3Enter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtFaxEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtWebEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtEMailEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtDireccionEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtCPEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtPoblacionEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtProvinciaEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtPaisEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtEntidadEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtOficinaEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtDCEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtIBANEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtCodigoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtDNIExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtCapitalExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtObservacionExit(Sender: TObject);
begin
  TDBMemo(sender).Color := clWindow;
  if (vtAccion = 'nuevo') and (txtDireccion.Text = '') then
  begin
    tabContacto.Show;
    txtContacto.SetFocus;
  end;
end;

procedure TformGDistribuidor.txtContactoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtTelefono2Exit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtTelefonoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtTelefono3Exit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtFaxExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtWebExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtFax2Exit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtEMailExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtDireccionExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtEntidadExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtOficinaExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtDCExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtIBANExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtPorcentajeBeneficioEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtPorcentajeBeneficioExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtPorcentajeBeneficioKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGDistribuidor.txtCapitalKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGDistribuidor.txtPorcentajeIVAEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGDistribuidor.txtPorcentajeIVAExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtPorcentajeIVAKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGDistribuidor.txtCPExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtPoblacionExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtProvinciaExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGDistribuidor.txtPaisExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

end.
