unit UnidadGEntradaAlmacen;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, Mask, forms, ComCtrls,
  variants, windows, dxCntner, dxEditor, dxExEdtr, dxEdLib, dxDBELib;

type
  TformGEntradaAlmacen = class(TForm)
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    lCodigo: TLabel;
    txtCodigo: TDBEdit;
    BGCodigoAuto: TSpeedButton;
    bSeleccionarParcela: TSpeedButton;
    txtParcela: TDBText;
    Label15: TLabel;
    Label3: TLabel;
    txtFecha: TdxDBDateEdit;
    Label4: TLabel;
    txtPesoNeto: TDBEdit;
    Label5: TLabel;
    Label1: TLabel;
    txtCodigoParcela: TDBEdit;
    txtObservacion: TDBMemo;
    Label13: TLabel;
    txtHora: TdxDBTimeEdit;
    txtMatricula: TDBComboBox;
    Label2: TLabel;
    opFinalizada: TDBCheckBox;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure TxtCPChange(Sender: TObject);
    procedure TxtTelefonoChange(Sender: TObject);
    procedure DBEdit3KeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    function generarCodigoAuto () : string;
    function cDuplicado (nombre : string) : boolean;

    procedure BGCodigoAutoClick(Sender: TObject);
    procedure txtCodigoExit(Sender: TObject);
    procedure bSeleccionarParcelaClick(Sender: TObject);
    procedure txtNombreExit(Sender: TObject);
    procedure txtCodigoEnter(Sender: TObject);
    procedure txtNombreEnter(Sender: TObject);
    procedure txtCodigoAgricultorEnter(Sender: TObject);
    procedure txtMatriculaEnter(Sender: TObject);
    procedure txtPesoNetoEnter(Sender: TObject);
    procedure txtFechaEnter(Sender: TObject);
    procedure txtMatriculaExit(Sender: TObject);
    procedure txtPesoNetoExit(Sender: TObject);
    procedure txtFechaExit(Sender: TObject);
    procedure txtCodigoParcelaExit(Sender: TObject);
    procedure txtCodigoParcelaKeyPress(Sender: TObject; var Key: Char);
    procedure txtHoraEnter(Sender: TObject);
    procedure txtHoraExit(Sender: TObject);
    procedure txtCodigoParcelaEnter(Sender: TObject);
    procedure txtObservacionEnter(Sender: TObject);
    procedure txtObservacionExit(Sender: TObject);
    procedure txtPesoNetoKeyPress(Sender: TObject; var Key: Char);

  private
    accionTemp : string;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formGEntradaAlmacen: TformGEntradaAlmacen;
const
  ventana = 'Entrada almacn';
  ventanas = 'Entradas almacn';

implementation


uses UnidadModuloDatos, UnidadProcedimientos, UnidadSeleccion;

var
  tTabla : TTable;
  //valorAnterior : string; //para modificacin de Nombre
{$R *.DFM}

//Genera el cdigo automticamente
function TformGEntradaAlmacen.generarCodigoAuto () : string;
var
  vano, vmes, vdia : word;
  contador : double;
begin
  DecodeDate(date, vano, vmes, vdia);
  with datos.tc do
  begin
    Close;
    SQL.Clear;  //obtenemos el contador de la tabla contadores
    SQL.Add('SELECT Contador');
    SQL.Add('FROM ' + vtTablaContador);
    SQL.Add('WHERE tabla = :pTabla');
    //SQL.Add('WHERE tabla = :pTabla AND anio = :pAno');
    //ParamByName('pAno').DataType := ftFloat;
    //ParamByName('pAno').Value := vano;
    ParamByName('pTabla').DataType := ftString;
    ParamByName('pTabla').Value := vtTablaEntradaAlmacen;
    Open;
    if FieldByName('Contador').value <> null then
    begin
      try
        contador := FieldByName('Contador').Value + 1;
        generarCodigoAuto := llenarCadena(floattostr(contador),6,'0', false);
        //Incrementamos el contador de la tabla contadores
        Close;
        SQL.Clear;
        SQL.Add('UPDATE ' + vtTablaContador +
            ' SET Contador = :pContador, CodigoUsuarioAlta = "'
            + vtCodigoUsuario + '" WHERE tabla = :pTabla');
             //+ vtCodigoUsuario + '" WHERE tabla = :pTabla AND anio = :pAno');
        //ParamByName('pAno').DataType := ftFloat;
        //ParamByName('pAno').Value := vano;
        ParamByName('pContador').DataType := ftFloat;
        ParamByName('pContador').Value := contador;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').Value := vtTablaEntradaAlmacen;
        ExecSQL;
        close;
      except
        Close;
        generarCodigoAuto := '0';
        MessageDlg ('El cdigo no ha podido generarse automticamente.', mtError, [mbOK], 0);
        txtCodigo.Enabled := true;
        txtCodigo.Visible := true;
        txtCodigo.SetFocus;
      end;
    end
    else  //si no existe el registro de contador para la tabla actual, lo creamos
    begin
      try
        Close;
        SQL.Clear;
        SQL.Add('INSERT INTO ' + vtTablaContador +
            ' (Anio, Tabla, Contador, Nota, Activo, CodigoUsuarioAlta) ' +
            ' VALUES (:pAno, :pTabla, 1, "Aadido automticamente", True, "' + vtCodigoUsuario + '")');
        ParamByName('pAno').DataType := ftFloat;
        ParamByName('pAno').Value := vano;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').Value := vtTablaEntradaAlmacen;
        ExecSQL;
        generarCodigoAuto := '000001';
        Close;
      except
        Close;
        MessageDlg ('El contador no se ha guardado correctamente.', mtError, [mbOK], 0);
      end;
    end;
  end;
end;

//comprobar nombre duplicado
function TformGEntradaAlmacen.cDuplicado (nombre : string) : boolean;
begin
  with datos.tc do
  begin
    Close;
    SQL.Clear;
    SQL.Add('SELECT COUNT(Codigo) Contador');
    SQL.Add('FROM ' + vtTablaEntradaAlmacen);
    SQL.Add('WHERE UPPER(nombre) = :pNombre');
    ParamByName('pNombre').DataType := ftString;
    ParamByName('pNombre').Value := AnsiUpperCase(nombre);
    Open;
    if FieldByName('Contador').value > 0 then
    begin
      Close;
      cDuplicado := true;
    end
    else
    begin
      Close;
      cDuplicado := false;
    end;
  end;
end;


procedure TformGEntradaAlmacen.BCancelarClick(Sender: TObject);
begin
  try
    ttabla.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TformGEntradaAlmacen.BAceptarClick(Sender: TObject);
begin
  //si el cdigo no se genera automticamente comprobar que est introducido
  if txtCodigo.Visible then
  begin
    if txtCodigo.Text = '' then
    begin
      MessageDlg ('El campo Cdigo debe tener un valor', mtWarning, [mbok], 0);
      TxtCodigo.setfocus;
      exit;
    end;
  end;
  if txtParcela.Caption = '' then
  begin
    MessageDlg ('La parcela introducida no existe, seleccione otra.', mtWarning, [mbok], 0);
    txtCodigoParcela.setfocus;
    exit;
  end;

  //si no existe la matrcula la aadimos
  if (datos.tEntradaAlmacenMatricula.Value <> '') and
      (datos.tEntradaAlmacenMatricula.Value <> null) then
  begin
    datos.tMatricula.Open;
    if not datos.tMatricula.Locate('Nombre', datos.tEntradaAlmacenMatricula.Value, []) then
    begin
      datos.tMatricula.Insert;
      datos.tMatriculaNombre.Value := datos.tEntradaAlmacenMatricula.Value;
      try
        datos.tMatricula.Post;
      except
      end;
    end;
  end;                  

  if ttabla.State  in [dsinsert, dsedit] then
  begin
    //Generar cdigo automticamente si es una insercin
    if (vtGCAEntradaAlmacen = true) and (vtAccion = 'nuevo') then
      txtcodigo.Text := generarCodigoAuto;
    tTabla.FieldByName('CodigoUsuarioAlta').Value := vtCodigoUsuario;
    tTabla.FieldByName('FechaAlta').Value := Date;
    tTabla.FieldByName('HoraAlta').Value := Time;
    try
      ttabla.Post; //validar
    except
      txtFecha.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TformGEntradaAlmacen.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ttabla.Close;
  action := cafree;
end;

procedure TformGEntradaAlmacen.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformGEntradaAlmacen.FormShow(Sender: TObject);
begin
  tTabla := datos.tEntradaAlmacen;
  datos.tParcela.Open;

  //obtenemos las matrculas
  datos.TC2.Close;
  datos.TC2.SQL.Clear;
  datos.TC2.SQL.Add('SELECT nombre FROM ' + vtTablaMatricula);
  datos.TC2.Open;
  if datos.TC2.RecordCount > 0 then
  begin
    while not datos.TC2.Eof do
    begin
      if not varisnull(datos.TC2.FieldByName('Nombre').Value) then
        txtMatricula.Items.Add(datos.TC2.FieldByName('Nombre').Value);
      datos.TC2.Next;
    end;
  end;

  if vtAccion = 'nuevo' then
  begin
    caption := 'Aadir ' + ventana + '...';
    bSeleccionarParcela.Visible := true;
    //Si no est activado generar cdigo automtico
    if (vtGCAEntradaAlmacen) = false then
    begin
      txtCodigo.Visible := true;
      txtCodigo.SetFocus;
      BGCodigoAuto.Visible := true;
    end
    else
      txtFecha.SetFocus;
    tTabla.Active := true;
    tTabla.Insert;
    tTabla.FieldByName('Finalizada').Value := false;
    tTabla.FieldByName('Fecha').Value := date;
    tTabla.FieldByName('Hora').Value := time;       
  end;

  if vtAccion = 'modificar' then
  begin
    bSeleccionarParcela.Visible := true;
    txtcodigo.Enabled := false;
    BGCodigoAuto.Enabled := false;
    caption := 'Modificacin de ' + ventana + '...';
    txtFecha.SetFocus;
    //valorAnterior := ttabla.fieldbyname('Nombre').Value;
    tTabla.Edit;
  end;

  if vtAccion = 'zoom' then
  begin
    tTabla.Active := true;
    tTabla.locate ('Codigo', vtCodigo, []);
    caption := 'Visualizacin de ' + ventana + '...';
    txtcodigo.Enabled := false;
    BGCodigoAuto.Enabled := false;
    txtFecha.Enabled := false;
    baceptar.Visible := false;
    bcancelar.SetFocus;
  end;
end;

procedure TformGEntradaAlmacen.TxtCPChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txtcp.text) = 5 then
      txttelefono.setfocus;
  end;}
end;

procedure TformGEntradaAlmacen.TxtTelefonoChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txttelefono.text) = 9 then
      opIVA.setfocus;
  end;}
end;

procedure TformGEntradaAlmacen.DBEdit3KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = '.' then
    key := ',';
end;

procedure TformGEntradaAlmacen.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //cambiar el foco con las teclas de cursor
  if (Key in [VK_UP, VK_DOWN]) and
      Not (ActiveControl is TDBComboBox) and not (ActiveControl is TDBMemo) then
  begin
    if Key = VK_UP then
      Perform(WM_NEXTDLGCTL, 1, 0)
    else
      Perform(WM_NEXTDLGCTL, 0, 0);
    Key := 0;
  end;
end;

procedure TformGEntradaAlmacen.BGCodigoAutoClick(Sender: TObject);
begin
  txtCodigo.Text := generarCodigoAuto;
end;

procedure TformGEntradaAlmacen.txtCodigoExit(Sender: TObject);
var
  i : integer;
  codigo : string;
begin
  TEdit(sender).Color := clWindow;
  codigo := txtCodigo.Text;
  if Length(codigo) < 6 then
  begin
    for i := 1 to 6 -length(codigo) do
      codigo := '0' + codigo;
    datos.tEntradaAlmacenCodigo.Value := codigo;
  end;
end;

procedure TformGEntradaAlmacen.bSeleccionarParcelaClick(Sender: TObject);
begin
  accionTemp := vtAccion;
  if (vtAccion = 'nuevo') or (vtAccion = 'modificar') then
  begin
    txtCodigoParcela.setfocus;
    application.createform(tformseleccion, formseleccion);
    formseleccion.tag := vtNumParcela;
    formseleccion.ShowModal;
    if vtClaveElegida <> '' then
    begin
      if vtClaveElegida <> '' then
      begin
        txtCodigoParcela.Text := vtClaveElegida;
        Perform(WM_NEXTDLGCTL, 0, 0);
      end;
    end;
  end;
  vtAccion := accionTemp;
end;

procedure TformGEntradaAlmacen.txtNombreExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGEntradaAlmacen.txtCodigoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGEntradaAlmacen.txtNombreEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGEntradaAlmacen.txtCodigoAgricultorEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGEntradaAlmacen.txtMatriculaEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGEntradaAlmacen.txtPesoNetoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGEntradaAlmacen.txtFechaEnter(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clMoneyGreen;
end;

procedure TformGEntradaAlmacen.txtMatriculaExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGEntradaAlmacen.txtPesoNetoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGEntradaAlmacen.txtFechaExit(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clWindow;
end;

procedure TformGEntradaAlmacen.txtCodigoParcelaExit(Sender: TObject);
var
  codigo : string;
  i : integer;
begin
  TEdit(sender).Color := clWindow;
  codigo := txtCodigoParcela.Text;
  if Length(codigo) < 4 then
  begin
    for i := 1 to 4 - length(codigo) do
      codigo := '0' + codigo;
    datos.tEntradaAlmacenCodigoParcela.Value := codigo;
  end;
  datos.TC2.Close;
  datos.tc2.SQL.Clear;
  datos.TC2.SQL.Add('SELECT Codigo, Nombre FROM ' + vtTablaParcela +
      ' WHERE codigo = :pCodigo');
  datos.TC2.ParamByName('pCodigo').Value := tTabla.fieldbyname('CodigoParcela').Value;
  datos.TC2.Open;
  if datos.TC2.RecordCount > 0 then
    txtParcela.Caption := datos.TC2.fieldbyname('Nombre').value;
end;

procedure TformGEntradaAlmacen.txtCodigoParcelaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '+' then
  begin
    key := chr(0);
    bSeleccionarParcelaClick(nil);
 end;
end;

procedure TformGEntradaAlmacen.txtHoraEnter(Sender: TObject);
begin
  TdxDBTimeEdit(sender).Color := clMoneyGreen;
end;

procedure TformGEntradaAlmacen.txtHoraExit(Sender: TObject);
begin
  TdxDBTimeEdit(sender).Color := clWindow;
end;

procedure TformGEntradaAlmacen.txtCodigoParcelaEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGEntradaAlmacen.txtObservacionEnter(Sender: TObject);
begin
  TDBMemo(sender).Color := clMoneyGreen;
end;

procedure TformGEntradaAlmacen.txtObservacionExit(Sender: TObject);
begin
  TDBMemo(sender).Color := clWindow;
end;

procedure TformGEntradaAlmacen.txtPesoNetoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

end.
