unit UnidadGFichaControl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Mask, Buttons, ExtCtrls, db, ComCtrls, Grids, DBGrids,
  ToolWin, Menus, ActnList, variants, inifiles, dxCntner, dxEditor,
  dxExEdtr, dxEdLib, dxDBELib, dbtables, strutils, QuickRpt, QRCtrls, dxTL,
  dxDBCtrl, dxDBGrid, dxDBTLCl, dxGrClms;

type
  TformGFichaControl = class(TForm)
    Panel1: TPanel;
    GCabeza: TGroupBox;
    Label8: TLabel;
    Label17: TLabel;
    BSeleccionar: TSpeedButton;
    txtParcela: TDBText;
    txtCodigoParcela: TDBEdit;
    GDetalle: TPanel;
    ActionList1: TActionList;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ActRefrescar: TAction;
    PopupMenu1: TPopupMenu;
    Aadir1: TMenuItem;
    Modificar1: TMenuItem;
    Eliminar1: TMenuItem;
    N1: TMenuItem;
    Refrescar1: TMenuItem;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    BAceptar: TBitBtn;
    Panel3: TPanel;
    BCancelar: TBitBtn;
    txtFecha: TdxDBDateEdit;
    txtCodigo: TDBEdit;
    lCodigo: TLabel;
    dtFichaDetalle: TDataSource;
    tcFichaDetalle: TQuery;
    tcFichaDetalleCodigo: TStringField;
    tcFichaDetalleCodigoFichaControl: TStringField;
    tcFichaDetalleFecha: TDateField;
    tcFichaDetalleOperacion: TStringField;
    tcFichaDetalleCodigoProducto: TStringField;
    tcFichaDetalleDosis: TFloatField;
    tcFichaDetalleGastoCaldo: TFloatField;
    tcFichaDetalleGastoCaldoUnidad: TStringField;
    tcFichaDetalleFechaDisposicion: TDateField;
    tcFichaDetalleCodigoUsuarioAlta: TStringField;
    tcFichaDetalleFechaAlta: TDateField;
    tcFichaDetalleHoraAlta: TTimeField;
    tcFichaDetalleProducto: TStringField;
    tcFichaDetallePlazoSeguridad: TFloatField;
    tcFichaDetalleUnidadDosis: TStringField;
    Tabla: TdxDBGrid;
    TablaCodigo: TdxDBGridMaskColumn;
    TablaFecha: TdxDBGridDateColumn;
    TablaProducto: TdxDBGridMaskColumn;
    TablaOperacion: TdxDBGridMaskColumn;
    TablaDosis: TdxDBGridMaskColumn;
    TablaUnidadDosis: TdxDBGridMaskColumn;
    TablaGastoCaldo: TdxDBGridMaskColumn;
    TablaGastoCaldoUnidad: TdxDBGridMaskColumn;
    TablaPlazoSeguridad: TdxDBGridMaskColumn;
    TablaFechaDisposicion: TdxDBGridDateColumn;
    TablaCodigoFichaControl: TdxDBGridMaskColumn;
    TablaCodigoProducto: TdxDBGridMaskColumn;
    TablaCodigoUsuarioAlta: TdxDBGridMaskColumn;
    TablaFechaAlta: TdxDBGridDateColumn;
    TablaHoraAlta: TdxDBGridTimeColumn;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit7KeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit13KeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarClick(Sender: TObject);
    procedure txtCodigoParcelaKeyPress(Sender: TObject;
  var Key: Char);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActModificarExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);

    function generarCodigoAuto () : string;

    procedure ordenar ();
    procedure txtCodigoParcelaExit(Sender: TObject);
    procedure txtCodigoParcelaEnter(Sender: TObject);
    procedure txtNumeroFacturaEnter(Sender: TObject);
    procedure txtCodigoEnter(Sender: TObject);
    procedure txtNumeroFacturaExit(Sender: TObject);
    procedure txtFechaExit(Sender: TObject);
    procedure txtFechaEnter(Sender: TObject);
    procedure txtPorcentajeIVAExit(Sender: TObject);
    procedure txtPorcentajeIVAKeyPress(Sender: TObject; var Key: Char);
    procedure txtImporteIVAKeyPress(Sender: TObject; var Key: Char);
    procedure txtBaseImponibleKeyPress(Sender: TObject; var Key: Char);
    procedure txtImporteTotalKeyPress(Sender: TObject; var Key: Char);
    procedure txtPorcentajeIVAEnter(Sender: TObject);
    procedure txtImporteIVAEnter(Sender: TObject);
    procedure txtBaseImponibleEnter(Sender: TObject);
    procedure txtImporteTotalEnter(Sender: TObject);
    procedure txtImporteIVAExit(Sender: TObject);
    procedure txtBaseImponibleExit(Sender: TObject);
    procedure txtImporteTotalExit(Sender: TObject);
    procedure txtCodigoExit(Sender: TObject);

  private
    tTabla : TTable;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formGFichaControl: TformGFichaControl;
const
  ventana = 'Ficha de control';
  ventanas = 'Fichas de control';

implementation

uses UnidadModuloDatos, UnidadMenuPrincipal, UnidadSeleccion,
    UnidadGFichaControlLinea, UnidadProcedimientos, UnidadImprimir;

{$R *.DFM}

//Genera el cdigo automticamente
function TformGFichaControl.generarCodigoAuto () : string;
var
  vano, vmes, vdia : word;
  contador : double;
begin
  DecodeDate(date, vano, vmes, vdia);
  with datos.tc do
  begin
    Close;
    SQL.Clear;  //obtenemos el contador de la tabla contadores
    SQL.Add('SELECT Contador');
    SQL.Add('FROM ' + vtTablaContador);
    SQL.Add('WHERE tabla = :pTabla');
    ParamByName('pTabla').DataType := ftString;
    ParamByName('pTabla').Value := vtTablaFichaControl;
    Open;
    if FieldByName('Contador').value <> null then
    begin
      try
        contador := FieldByName('Contador').Value + 1;
        generarCodigoAuto := llenarCadena(floattostr(contador), 5, '0', false);
        //Incrementamos el contador de la tabla contadores
        Close;
        SQL.Clear;
        SQL.Add('UPDATE ' + vtTablaContador +
            ' SET Contador = :pContador, CodigoUsuarioAlta = "'
            + vtCodigoUsuario + '" WHERE tabla = :pTabla');
             //+ vtCodigoUsuario + '" WHERE tabla = :pTabla AND anio = :pAno');
        //ParamByName('pAno').DataType := ftFloat;
        //ParamByName('pAno').Value := vano;
        ParamByName('pContador').DataType := ftFloat;
        ParamByName('pContador').Value := contador;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').Value := vtTablaFichaControl;
        ExecSQL;
        close;
      except
        Close;
        generarCodigoAuto := '0';
        MessageDlg ('El cdigo no ha podido generarse automticamente.', mtError, [mbOK], 0);
        txtCodigo.Enabled := true;
        txtCodigo.Visible := true;
        txtCodigo.SetFocus;
      end;
    end
    else  //si no existe el registro de contador para la tabla actual, lo creamos
    begin
      try
        Close;
        SQL.Clear;
        SQL.Add('INSERT INTO ' + vtTablaContador +
            ' (Anio, Tabla, Contador, Nota, Activo, CodigoUsuarioAlta) ' +
            ' VALUES (:pAno, :pTabla, 1, "Aadido automticamente", True, "' + vtCodigoUsuario + '")');
        ParamByName('pAno').DataType := ftFloat;
        ParamByName('pAno').Value := vano;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').Value := vtTablaFichaControl;
        ExecSQL;
        generarCodigoAuto := '00001';
        Close;
      except
        Close;
        MessageDlg ('El contador no se ha guardado correctamente.', mtError, [mbOK], 0);
      end;
    end;
  end;
end;



procedure TformGFichaControl.BCancelarClick(Sender: TObject);
begin
  try
    if (tTabla.State = dsedit) or (tTabla.State = dsinsert) then
    begin
      if MessageDlg('Desea guardar los cambios realizados?', mtConfirmation,
          [mbyes, mbno], 0) = mryes then
      begin
        if txtParcela.Caption = '' then
        begin
         MessageDlg ('La parcela seleccionada no existe.', mtWarning, [mbok], 0);
         txtCodigoParcela.setfocus;
         exit;
        end;             
        if (TxtFecha.Text = '') or (txtfecha.text = '  /  /  ') then
        begin
          messagedlg ('El campo Fecha debe tener un valor.', mtWarning, [mbok], 0);
          txtFecha.setfocus;
          exit;
        end;
        if txtCodigo.Text = '' then
          generarCodigoAuto;
        if txtCodigo.Text = '' then
        begin
          messagedlg ('El cdigo de la factura actual no ha podido generarse ' +
              'automticamente. Los cambios no sern guardados.',
              mtError, [mbok], 0);
          tTabla.Cancel;
          close;    
        end;
        tTabla.Post;
      end
      else
        tTabla.Cancel;
    end;
  except
    //silenciosa
  end;
  close;
end;

procedure TformGFichaControl.BAceptarClick(Sender: TObject);
begin
  if (vtGCAFichaControl = false) and (txtCodigo.Text = '') then
  begin
    MessageDlg ('El Cdigo debe tener un valor.', mtWarning, [mbok], 0);
    txtCodigo.setfocus;
    exit;
  end;
  if txtParcela.Caption = '' then
  begin
    MessageDlg ('La Parcela seleccionada no existe.', mtWarning, [mbok], 0);
    txtCodigoParcela.setfocus;
    exit;
  end;

  if (TxtFecha.Text = '') or (txtfecha.text = '  /  /  ') then
  begin
    messagedlg ('Debe introducir la fecha de la ' + ventana,
        mtinformation, [mbok], 0);
    txtFecha.setfocus;
    exit;
  end;

  //si se aade una nueva y hay que generar el cdigo automtico
  if (vtGCAFichaControl = true) and (vtAccion = 'nuevo') then
  begin
    txtcodigo.Text := generarCodigoAuto;
    if txtCodigo.Text = '' then
    begin
      MessageDlg('El cdigo no ha podido generarse correctamente.', mtError, [mbok],0);
      exit;
    end;
  end;
  if tTabla.State  in [dsinsert, dsedit] then
  begin
    try
      tTabla.Post; //validar
    except
      txtCodigoParcela.setfocus;
      raise;
      exit;
    end;
  end;
  GDetalle.Enabled := true;
  ActNuevo.Enabled := true;
  ActModificar.Enabled := true;
  ActEliminar.Enabled := true;
  ActRefrescar.Enabled := true;
  vtAccion := '';
end;

procedure TformGFichaControl.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action := cafree;
end;                                                                                                                                                                                                                                                                                                                                                                      

procedure TformGFichaControl.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformGFichaControl.DBEdit7KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGFichaControl.DBEdit13KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGFichaControl.BSeleccionarClick(Sender: TObject);
begin
  txtCodigoParcela.SetFocus;
  application.createform(tformseleccion, formseleccion);
  formseleccion.ActNuevo.Enabled := true;
  formseleccion.tag := vtNumParcela;
  formseleccion.ShowModal;
  if vtClaveElegida <> '' then
    txtCodigoParcela.Text := vtClaveElegida;
  tTabla.Edit;
end;

procedure TformGFichaControl.txtCodigoParcelaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '+' then
  begin
    key := chr(0);
    BSeleccionarClick(nil);
  end;
end;

procedure TformGFichaControl.ActNuevoExecute(Sender: TObject);
begin
  if (TxtFecha.Text = '') then
  begin
    messagedlg ('Debe introducir la fecha del ' + ventana,
        mtinformation, [mbok], 0);
    txtFecha.setfocus;
    exit;
  end;

  if tTabla.State  in [dsinsert, dsedit] then
  begin
    try
      tTabla.Post; //validar
    except
      txtCodigoParcela.setfocus;
      raise;
      exit;
    end;
  end;
  tag := 1; //nuevo
  if not varisnull(datos.tFichaControlFecha.Value) then
    vtfechaalta := datos.tFichaControlFecha.Value
  else
    vtFechaAlta := date;
  application.createform(TformGFichaControlLinea, formGFichaControlLinea);
  formGFichaControlLinea.ShowModal;
  vtCodigoTerceroFactura := '';
  ActRefrescarExecute(nil);
end;

procedure tformGFichaControl.ordenar ();
begin
  with TCFichaDetalle do
  begin
    sql.Clear;
    sql.add ('SELECT fcd.*, p. Nombre Producto');
    sql.add ('FROM ' + vtTablaFichaControlDetalle  + ' fcd, ' + vtTablaProducto + ' p');
    sql.add ('WHERE fcd.CodigoProducto = p.Codigo AND fcd.CodigoFichaControl = :pCodigo');
    ParamByName('pCodigo').DataType := ftString;
    ParamByName('pCodigo').Value := tTabla.fieldbyname('Codigo').value;
    try
      open;
    except
      raise;
    end;
  end;
end;

procedure TformGFichaControl.ActRefrescarExecute(Sender: TObject);
begin
  if (TxtFecha.Text = '') then
  begin
    messagedlg ('Debe introducir la fecha de la ' + ventana,
        mtinformation, [mbok], 0);
    txtFecha.setfocus;
    exit;
  end;
  if ttabla.State  in [dsinsert, dsedit] then
  begin
    try
      ttabla.Post; //validar
    except
      txtCodigoParcela.setfocus;
      raise;
      exit;
    end;
  end;
  ordenar();
end;

procedure TformGFichaControl.ActModificarExecute(Sender: TObject);
begin
  if tcFichaDetalle.State <> dsinactive then
  begin
    if (TxtFecha.Text = '') then
    begin
      messagedlg ('Debe introducir la fecha de la ' + ventana, mtinformation, [mbok], 0);
      txtFecha.setfocus;
      exit;
    end;

    if ttabla.State  in [dsinsert, dsedit] then
    begin
      try
        ttabla.Post; //validar
      except
        txtCodigoParcela.setfocus;
        raise;
        exit;
      end;
    end;
    tag := 2; //modificar
    if tcFichaDetalle.RecordCount <= 0 then
      messagedlg ('No hay datos.', mtinformation,[mbok],0)
    else
    begin
      if not varisnull(tcFichaDetalle.fieldbyname('Codigo').value) then
      begin
        vtAccion := 'modificar';
        datos.tFichaControlDetalle.Active:= true;
        datos.tFichaControlDetalle.Locate ('Codigo',
            tcFichaDetalleCodigo.value,[]);
        datos.tFichaControlDetalle.edit;
        application.createform(TformGFichaControlLinea, formGFichaControlLinea);
        formGFichaControlLinea.ShowModal;
        ActRefrescarExecute(nil);
      end;
    end;
  end;
end;

procedure TformGFichaControl.ActEliminarExecute(Sender: TObject);
var
  nombre : String;
begin
  if (TxtFecha.Text = '') then
  begin
    messagedlg ('Debe introducir la fecha del ' + ventana,
        mtinformation, [mbok], 0);
    txtFecha.setfocus;
    exit;
  end;

  if tTabla.State  in [dsinsert, dsedit] then
  begin
    try
      tTabla.Post; //validar
    except
      txtCodigoParcela.setfocus;
      raise;
      exit;
    end;
  end;

  if tcFichaDetalle.RecordCount <= 0 then
    messagedlg ('No hay datos.', mtinformation,[mbok],0)
  else
  begin
    datos.tc.close;
    datos.tFichaControlDetalle.Active := true;
    if datos.tFichaControlDetalle.locate('Codigo',
        tcFichaDetalle.fieldbyname('Codigo').value, []) then
    begin
      if not varisnull(datos.tFichaControlDetalleCodigo.Value) then
        nombre := datos.tFichaControlDetalleCodigo.Value
      else
        nombre := '';
      if messagedlg ('Est seguro que desea eliminar la ' + ventana + ' [ ' +
          nombre + ' ]?', mtconfirmation, [mbyes, mbno], 0) = mryes then
      begin
        try
          datos.tFichaControlDetalle.delete;
          ActRefrescarExecute(nil);
        except
          raise;
        end;
      end;
    end;
  end;
end;

procedure TformGFichaControl.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //cambiar el foco con las teclas de cursor
  if (Key in [VK_UP, VK_DOWN]) and
      Not (ActiveControl is TDBComboBox) and not (ActiveControl is TDBGrid) and
      not (activecontrol is tdxdbdateedit) then
  begin
    if Key = VK_UP then
      Perform(WM_NEXTDLGCTL, 1, 0)
    else
      Perform(WM_NEXTDLGCTL, 0, 0);
    Key := 0;
  end;
end;

procedure TformGFichaControl.FormShow(Sender: TObject);
begin
  caption := ventanas;
  datos.tParcela.Open;

  tTabla := datos.tFichaControl;
  if vtAccion = 'nuevo' then
  begin
    tcFichaDetalle.Close;
    caption := 'Aadir ' + ventana + '...';;
    //Si no est activado generar cdigo automtico
    if (vtGCAFichaControl) = false then
    begin
      txtCodigo.Visible := true;
      lCodigo.Visible := true;
      txtCodigo.SetFocus;
    end
    else
    begin
      txtCodigo.Visible := false;
      lCodigo.Visible := false;
      txtCodigoParcela.SetFocus;
    end;
    tTabla.Active := true;
    tTabla.Insert;
    //Valores por defecto
    tTabla.FieldByName('Fecha').value := date;
    GDetalle.Enabled := false;
    ActNuevo.Enabled := false;
    ActModificar.Enabled := false;
    ActEliminar.Enabled := false;
    ActRefrescar.Enabled := false;
  end;

  if vtAccion = 'modificar' then
  begin
    txtcodigo.Enabled := false;
    caption := 'Modificacin de ' + ventana + '...';
    txtCodigoParcela.SetFocus;
    GDetalle.Enabled := true;
    ActNuevo.Enabled := true;
    ActModificar.Enabled := true;
    ActEliminar.Enabled := true;
    ActRefrescar.Enabled := true;
    tcFichaDetalle.Close;
    tcFichaDetalle.SQL.Clear;
    ActRefrescarExecute(nil);
    tTabla.Edit;
  end;

  if vtAccion = 'zoom' then
  begin
    tTabla.Active := true;
    tTabla.locate ('Codigo', vtCodigo, []);
    caption := 'Visualizacin de ' + ventana + '...';
    txtcodigo.Enabled := false;
    txtParcela.Enabled := false;
    baceptar.Visible := false;
    bcancelar.SetFocus;
    GDetalle.Enabled := true;
    ActNuevo.Enabled := false;
    ActModificar.Enabled := false;
    ActEliminar.Enabled := false;
    ActRefrescar.Enabled := true;
    ActRefrescarExecute(nil);
  end;
end;

procedure TformGFichaControl.txtCodigoParcelaExit(Sender: TObject);
var
  i : integer;
  codigo : string;
begin
  TEdit(sender).Color := clWindow;
  codigo := txtCodigoParcela.Text;
  if Length(codigo) < 4 then
  begin
    for i := 1 to 4 -length(codigo) do
      codigo := '0' + codigo;
    tTabla.FieldByName('CodigoParcela').Value := codigo;
  end;
  datos.TC2.Close;
  datos.tc2.SQL.Clear;
  datos.TC2.SQL.Add('SELECT Codigo, Nombre' +
      ' FROM ' + vtTablaParcela +
      ' WHERE codigo = :pCodigo');
  datos.TC2.ParamByName('pCodigo').Value := tTabla.fieldbyname('CodigoParcela').Value;
  datos.TC2.Open;
  if datos.TC2.RecordCount > 0 then
    txtParcela.Caption := datos.TC2.fieldbyname('Nombre').value;
end;

procedure TformGFichaControl.txtCodigoParcelaEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControl.txtNumeroFacturaEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControl.txtCodigoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControl.txtNumeroFacturaExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFichaControl.txtFechaExit(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clWindow;
end;

procedure TformGFichaControl.txtFechaEnter(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControl.txtPorcentajeIVAExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
  tTabla.Edit;
  tTabla.FieldByName('BaseImponible').Value := 0;
  tTabla.Post;
  ordenar;
end;

procedure TformGFichaControl.txtPorcentajeIVAKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGFichaControl.txtImporteIVAKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGFichaControl.txtBaseImponibleKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGFichaControl.txtImporteTotalKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGFichaControl.txtPorcentajeIVAEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControl.txtImporteIVAEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControl.txtBaseImponibleEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControl.txtImporteTotalEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControl.txtImporteIVAExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFichaControl.txtBaseImponibleExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFichaControl.txtImporteTotalExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFichaControl.txtCodigoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

end.
