unit UnidadGFichaControlLinea;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Mask, Buttons, ExtCtrls, db, ComCtrls, variants,
  dxCntner, dxEditor, dxExEdtr, dxEdLib, dxDBELib;

type
  TformGFichaControlLinea = class(TForm)
    Panel1: TPanel;
    txtCodigoProducto: TDBEdit;
    Label1: TLabel;
    BCancelar: TBitBtn;
    BAceptar: TBitBtn;
    txtCaldo: TDBEdit;
    BSeleccionarProducto: TSpeedButton;
    txtProducto: TDBText;
    Label2: TLabel;
    txtDosis: TDBEdit;
    Label3: TLabel;
    txtCodigo: TDBEdit;
    lbCodigo: TLabel;
    txtFecha: TdxDBDateEdit;
    Label8: TLabel;
    lUnidadDosis: TLabel;
    Label4: TLabel;
    txtOperacion: TDBComboBox;
    Label5: TLabel;
    txtPlazo: TDBEdit;
    Label6: TLabel;
    txtFechaDisposicion: TdxDBDateEdit;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure txtCaldoKeyPress(Sender: TObject; var Key: Char);
    procedure txtCodigoProductoKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarProductoClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    function generarCodigoAuto () : string;
    procedure txtCodigoEnter(Sender: TObject);
    procedure txtCodigoProductoEnter(Sender: TObject);
    procedure txtDosisEnter(Sender: TObject);
    procedure txtConceptoEnter(Sender: TObject);
    procedure txtCaldoEnter(Sender: TObject);
    procedure txtFechaEnter(Sender: TObject);
    procedure txtCodigoExit(Sender: TObject);
    procedure txtDosisExit(Sender: TObject);
    procedure txtConceptoExit(Sender: TObject);
    procedure txtCaldoExit(Sender: TObject);
    procedure txtFechaExit(Sender: TObject);
    procedure txtCodigoProductoExit(Sender: TObject);
    procedure txtPlazoEnter(Sender: TObject);
    procedure txtPlazoExit(Sender: TObject);
    procedure txtFechaDisposicionEnter(Sender: TObject);
    procedure txtFechaDisposicionExit(Sender: TObject);
    procedure txtOperacionEnter(Sender: TObject);
    procedure txtOperacionExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formGFichaControlLinea: TformGFichaControlLinea;
const
  ventana = 'Lnea de Ficha de control';
  ventanas = 'Lneas de Ficha de control';

implementation

uses UnidadModuloDatos, UnidadMenuPrincipal, UnidadSeleccion,
  UnidadGFichaControl, UnidadProcedimientos;

{$R *.DFM}

//Genera el cdigo automticamente
function TformGFichaControlLinea.generarCodigoAuto () : string;
var
  vano, vmes, vdia : word;
  contador : double;
begin
  DecodeDate(date, vano, vmes, vdia);
  with datos.tc do
  begin
    Close;
    SQL.Clear;  //obtenemos el contador de la tabla contadores
    SQL.Add('SELECT Contador');
    SQL.Add('FROM ' + vtTablaContador);
    SQL.Add('WHERE tabla = :pTabla');
    ParamByName('pTabla').DataType := ftString;
    ParamByName('pTabla').Value := vtTablaFichaControlDetalle;
    Open;
    if FieldByName('Contador').value <> null then
    begin
      try
        contador := FieldByName('Contador').Value + 1;
        generarCodigoAuto := llenarCadena(floattostr(contador),8,'0', false);
        //Incrementamos el contador de la tabla contadores
        Close;
        SQL.Clear;
        SQL.Add('UPDATE ' + vtTablaContador +
            ' SET Contador = :pContador, CodigoUsuarioAlta = "'
            + vtCodigoUsuario + '" WHERE tabla = :pTabla');
        ParamByName('pContador').DataType := ftFloat;
        ParamByName('pContador').Value := contador;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').Value := vtTablaFichaControlDetalle;
        ExecSQL;
        close;
      except
        Close;
        generarCodigoAuto := '0';
        MessageDlg ('El cdigo no ha podido generarse automticamente.', mtError, [mbOK], 0);
        txtCodigo.Enabled := true;
        txtCodigo.Visible := true;
        txtCodigo.SetFocus;
      end;
    end
    else  //si no existe el registro de contador para la tabla actual, lo creamos
    begin
      try
        Close;
        SQL.Clear;
        SQL.Add('INSERT INTO ' + vtTablaContador +
            ' (Anio, Tabla, Contador, Nota, Activo, CodigoUsuarioAlta) ' +
            ' VALUES (:pAno, :pTabla, 1, "Aadido automticamente", True, "' + vtCodigoUsuario + '")');
        ParamByName('pAno').DataType := ftFloat;
        ParamByName('pAno').Value := vano;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').Value := vtTablaFichaControlDetalle;
        ExecSQL;
        generarCodigoAuto := '00000001';
        Close;
      except
        Close;
        MessageDlg ('El contador no se ha guardado correctamente.', mtError, [mbOK], 0);
      end;
    end;
  end;
end;


procedure TformGFichaControlLinea.BCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TformGFichaControlLinea.BAceptarClick(Sender: TObject);
begin
  if txtCodigoProducto.Text = '' then
  begin
    messagedlg ('Debe introducir un Cdigo de producto.', mtinformation, [mbok], 0);
    txtCodigoProducto.setfocus;
    exit;
  end;

  if datos.tFichaControlDetalleFechaDisposicion.Value <
      datos.tFichaControlDetalleFecha.Value then
  begin
    messagedlg ('La fecha de disposicin no puede ser menor que la fecha de ' +
        'aplicacin.', mtinformation, [mbok], 0);
    txtFecha.setfocus;
    exit;
  end;

  if txtProducto.Caption = '' then
  begin
    messagedlg ('El cdigo introducido no existe en Productos.', mtinformation, [mbok], 0);
    txtCodigoProducto.setfocus;
    exit;
  end;
  if datos.tFichaControlDetalle.State  in [dsinsert, dsedit] then
  begin
    //Generamos el cdigo automtico
    if (vtGCAFichaControlDetalle = true) and (formGFichaControl.Tag = 1) then //nuevo
    begin
      txtcodigo.Text := generarCodigoAuto;
      if txtCodigo.Text = '' then
      begin
        MessageDlg('El cdigo no ha podido generarse correctamente.', mtError, [mbok],0);
        exit;
      end;
    end;
    try
      datos.tFichaControlDetalle.Post; //validar
    except
      txtCodigoProducto.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TformGFichaControlLinea.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    if (datos.tFichaControlDetalle.State = dsedit) or
        (datos.tFichaControlDetalle.State = dsinsert) then
      datos.tFichaControlDetalle.cancel;
  except
    //silenciosa
  end;
  action := cafree;
end;                                                                                                                                                                                                                                                                                                                                                                      

procedure TformGFichaControlLinea.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformGFichaControlLinea.FormShow(Sender: TObject);
begin
  datos.tProducto.Open;
  if formGFichaControl.tag = 1 then //Nuevo
  begin
    caption := 'Nueva ' + ventana + '...';
    datos.tFichaControlDetalle.Open;    
    //Si no est activado generar cdigo automtico
    if (vtGCAFichaControlDetalle) = false then
    begin
      txtCodigo.Visible := true;
      txtCodigo.SetFocus;
    end
    else
    begin
      lbCodigo.Visible := false;
      txtCodigo.Visible := false;
      txtFecha.SetFocus;
    end;
    datos.tFichaControlDetalle.Insert;
    datos.tFichaControlDetalle.FieldByName('CodigoFichaControl').Value :=
        Datos.tFichaControlCodigo.Value;
    datos.tFichaControlDetalleFecha.Value := vtFechaAlta;
    datos.tFichaControlDetalleOperacion.Value := 'Tratamiento fitosanitario';
  end;

  if formGFichaControl.tag = 2 then //Modificar
  begin
    TxtCodigo.Enabled := false;
    txtCodigo.Visible := true;
    BSeleccionarProducto.Enabled := true;
    datos.tFichaControlDetalle.edit;
    txtFecha.SetFocus;
    caption := 'Modificacin de ' + ventana + '...';
  end;
  if formGFichaControl.tag = 3 then //zoom
  begin
    TxtCodigo.Enabled := false;
    txtCodigo.Visible := true;
    BAceptar.Visible := false;
    BSeleccionarProducto.Enabled := false;
    caption := 'Visualizar de ' + ventana + '...';
  end;
end;

procedure TformGFichaControlLinea.txtCaldoKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;


procedure TformGFichaControlLinea.txtCodigoProductoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if formGFichaControl.Tag <> 3 then //zoom
  begin
    if key = '+' then
    begin
      key := chr(0);
      BSeleccionarProductoClick(nil);
    end;
  end;
end;

procedure TformGFichaControlLinea.BSeleccionarProductoClick(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.ActNuevo.Enabled := true;
  formseleccion.tag := vtNumProducto;
  formseleccion.ShowModal;
  if vtClaveElegida <> '' then
    txtCodigoProducto.Text := vtClaveElegida;
  //datos.tFichaControlDetalle.FieldByName('CodigoProducto').RefreshLookupList;
end;

procedure TformGFichaControlLinea.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //teclas de cursor para cambiar el foco
  if (Key in [VK_UP, VK_DOWN]) and
      Not (ActiveControl is TDBComboBox) and not (activecontrol is tdbmemo) then
  begin
    if Key = VK_UP then
      Perform(WM_NEXTDLGCTL, 1, 0)
    else
      Perform(WM_NEXTDLGCTL, 0, 0);
    Key := 0;
  end;
end;

procedure TformGFichaControlLinea.txtCodigoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControlLinea.txtCodigoProductoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControlLinea.txtDosisEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControlLinea.txtConceptoEnter(Sender: TObject);
begin
  TDBMemo(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControlLinea.txtCaldoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControlLinea.txtFechaEnter(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControlLinea.txtCodigoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFichaControlLinea.txtDosisExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFichaControlLinea.txtConceptoExit(Sender: TObject);
begin
  TDBMemo(sender).Color := clWindow;
end;

procedure TformGFichaControlLinea.txtCaldoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFichaControlLinea.txtFechaExit(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clWindow;
end;

procedure TformGFichaControlLinea.txtCodigoProductoExit(Sender: TObject);
var
  codigo : string;
  i : integer;
begin
  TEdit(sender).Color := clWindow;
  codigo := datos.tFichaControlDetalleCodigoProducto.AsString;
  if Length(codigo) < 8 then
  begin
    for i := 1 to 7 - length(codigo) do
      codigo := '0' + codigo;
    datos.tFichaControlDetalleCodigoProducto.Value := codigo;
  end;
  datos.tc2.Close;
  datos.tc2.SQL.Clear;
  datos.tc2.SQL.Add('SELECT * FROM ' + vtTablaProducto + ' WHERE Codigo = :pCodigo');
  datos.tc2.ParamByName('pCodigo').DataType := ftString;
  datos.tc2.ParamByName('pCodigo').Value := codigo;
  datos.tc2.Open;
  if datos.tc2.RecordCount > 0 then
  begin
    if (datos.tc2.FieldByName('PlazoSeguridad').Value <> null) and
        (datos.tc2.FieldByName('PlazoSeguridad').Value <> 0) then
      datos.tFichaControlDetallePlazoSeguridad.Value :=
          datos.tc2.FieldByName('PlazoSeguridad').Value;
    if (datos.tc2.FieldByName('Dosis').Value <> null) and
        (datos.tc2.FieldByName('Dosis').Value <> 0) then
      datos.tFichaControlDetalleDosis.Value :=
          datos.tc2.FieldByName('Dosis').Value;
    if (datos.tc2.FieldByName('UnidadDosis').Value <> null) then
      datos.tFichaControlDetalleUnidadDosis.Value :=
          datos.tc2.FieldByName('UnidadDosis').Value;
    if (datos.tc2.FieldByName('PlazoSeguridad').Value <> null) then
      datos.tFichaControlDetalleFechaDisposicion.Value := date +
          datos.tc2.FieldByName('PlazoSeguridad').Value;
  end;
end;

procedure TformGFichaControlLinea.txtPlazoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControlLinea.txtPlazoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
  if not VarIsNull(datos.tFichaControlDetalleFecha.Value) and
      not varisnull (datos.tFichaControlDetallePlazoSeguridad.Value) then
    datos.tFichaControlDetalleFechaDisposicion.Value :=
        datos.tFichaControlDetalleFecha.Value +
        datos.tFichaControlDetallePlazoSeguridad.Value;
end;

procedure TformGFichaControlLinea.txtFechaDisposicionEnter(
  Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControlLinea.txtFechaDisposicionExit(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clWindow;
end;

procedure TformGFichaControlLinea.txtOperacionEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGFichaControlLinea.txtOperacionExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
  if (datos.tFichaControlDetalleOperacion.Value = 'Recoleccin') or
      (datos.tFichaControlDetalleOperacion.Value = 'Riego') or
      (datos.tFichaControlDetalleOperacion.Value = 'Transplante') or
      (datos.tFichaControlDetalleOperacion.Value = 'Siembra') or
      (datos.tFichaControlDetalleOperacion.Value = 'Otro') then
  begin
    datos.tFichaControlDetalleCodigoProducto.Value := vtCodigoProducto;
    datos.tFichaControlDetalleDosis.Value := 0;
    datos.tFichaControlDetalleGastoCaldo.Value := 0;
    datos.tFichaControlDetallePlazoSeguridad.Value := 0;
    if not varisnull(datos.tFichaControlDetalleFecha.Value) then
      datos.tFichaControlDetalleFechaDisposicion.Value :=
          datos.tFichaControlDetalleFecha.Value
    else
      datos.tFichaControlDetalleFechaDisposicion.Value := date;
  end;
end;

end.
