unit UnidadGPaletLinea;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Mask, Buttons, ExtCtrls, db, ComCtrls, variants,
  dxCntner, dxEditor, dxExEdtr, dxEdLib, dxDBELib;

type
  TformGPaletLinea = class(TForm)
    Panel1: TPanel;
    txtCodigoEntrada: TDBEdit;
    Label1: TLabel;
    BCancelar: TBitBtn;
    BAceptar: TBitBtn;
    BSeleccionarProducto: TSpeedButton;
    Label2: TLabel;
    txtPesoNeto: TDBEdit;
    txtCodigo: TDBEdit;
    lbCodigo: TLabel;
    GroupBox1: TGroupBox;
    lInfo: TLabel;
    lInfo2: TLabel;
    lInfo3: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    lInfo4: TLabel;
    lInfo5: TLabel;
    Label8: TLabel;
    txtNumeroEnvases: TDBEdit;
    Label7: TLabel;
    txtTipoEnvase: TDBComboBox;
    Label9: TLabel;
    Label10: TLabel;
    txtTaraEnvase: TDBEdit;
    bCalcularPN: TButton;
    Label15: TLabel;
    lInfoProveedor: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    GroupBox2: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    txtProducto: TDBComboBox;
    txtVariedad: TDBComboBox;
    txtCalibre: TDBComboBox;
    txtCategoria: TDBComboBox;
    Label18: TLabel;
    txtNumeroLote: TDBEdit;
    bObtenerLote: TButton;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure txtCodigoEntradaKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarProductoClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    function generarCodigoAuto () : string;
    procedure obtenerEntrada;
    
    procedure txtCodigoEnter(Sender: TObject);
    procedure txtCodigoEntradaEnter(Sender: TObject);
    procedure txtPesoNetoEnter(Sender: TObject);
    procedure txtConceptoEnter(Sender: TObject);
    procedure txtCaldoEnter(Sender: TObject);
    procedure txtFechaEnter(Sender: TObject);
    procedure txtCodigoExit(Sender: TObject);
    procedure txtPesoNetoExit(Sender: TObject);
    procedure txtConceptoExit(Sender: TObject);
    procedure txtCaldoExit(Sender: TObject);
    procedure txtFechaExit(Sender: TObject);
    procedure txtCodigoEntradaExit(Sender: TObject);
    procedure txtPlazoEnter(Sender: TObject);
    procedure txtPlazoExit(Sender: TObject);
    procedure txtFechaDisposicionEnter(Sender: TObject);
    procedure txtFechaDisposicionExit(Sender: TObject);
    procedure txtOperacionEnter(Sender: TObject);
    procedure txtOperacionExit(Sender: TObject);
    procedure txtPesoNetoKeyPress(Sender: TObject; var Key: Char);
    procedure txtTaraEnvaseExit(Sender: TObject);
    procedure txtTaraEnvaseEnter(Sender: TObject);
    procedure txtTipoEnvaseExit(Sender: TObject);
    procedure txtTipoEnvaseEnter(Sender: TObject);
    procedure txtNumeroEnvasesEnter(Sender: TObject);
    procedure txtNumeroEnvasesExit(Sender: TObject);
    procedure bCalcularPNClick(Sender: TObject);
    procedure txtProductoEnter(Sender: TObject);
    procedure txtVariedadEnter(Sender: TObject);
    procedure txtCalibreEnter(Sender: TObject);
    procedure txtCategoriaEnter(Sender: TObject);
    procedure txtProductoExit(Sender: TObject);
    procedure txtVariedadExit(Sender: TObject);
    procedure txtCalibreExit(Sender: TObject);
    procedure txtCategoriaExit(Sender: TObject);
    procedure bObtenerLoteClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formGPaletLinea: TformGPaletLinea;
const
  ventana = 'Lnea de Palet';
  ventanas = 'Lneas de Palet';

implementation

uses UnidadModuloDatos, UnidadMenuPrincipal, UnidadSeleccion,
  UnidadGPalet, UnidadProcedimientos;

{$R *.DFM}

//Genera el cdigo automticamente
function TformGPaletLinea.generarCodigoAuto () : string;
var
  vano, vmes, vdia : word;
  contador : double;
begin
  DecodeDate(date, vano, vmes, vdia);
  with datos.tc do
  begin
    Close;
    SQL.Clear;  //obtenemos el contador de la tabla contadores
    SQL.Add('SELECT Contador');
    SQL.Add('FROM ' + vtTablaContador);
    SQL.Add('WHERE tabla = :pTabla');
    ParamByName('pTabla').DataType := ftString;
    ParamByName('pTabla').Value := vtTablaPaletDetalle;
    Open;
    if FieldByName('Contador').value <> null then
    begin
      try
        contador := FieldByName('Contador').Value + 1;
        generarCodigoAuto := llenarCadena(floattostr(contador),8,'0', false);
        //Incrementamos el contador de la tabla contadores
        Close;
        SQL.Clear;
        SQL.Add('UPDATE ' + vtTablaContador +
            ' SET Contador = :pContador, CodigoUsuarioAlta = "'
            + vtCodigoUsuario + '" WHERE tabla = :pTabla');
        ParamByName('pContador').DataType := ftFloat;
        ParamByName('pContador').Value := contador;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').Value := vtTablaPaletDetalle;
        ExecSQL;
        close;
      except
        Close;
        generarCodigoAuto := '0';
        MessageDlg ('El cdigo no ha podido generarse automticamente.', mtError, [mbOK], 0);
        txtCodigo.Enabled := true;
        txtCodigo.Visible := true;
        txtCodigo.SetFocus;
      end;
    end
    else  //si no existe el registro de contador para la tabla actual, lo creamos
    begin
      try
        Close;
        SQL.Clear;
        SQL.Add('INSERT INTO ' + vtTablaContador +
            ' (Anio, Tabla, Contador, Nota, Activo, CodigoUsuarioAlta) ' +
            ' VALUES (:pAno, :pTabla, 1, "Aadido automticamente", True, "' + vtCodigoUsuario + '")');
        ParamByName('pAno').DataType := ftFloat;
        ParamByName('pAno').Value := vano;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').Value := vtTablaPaletDetalle;
        ExecSQL;
        generarCodigoAuto := '00000001';
        Close;
      except
        Close;
        MessageDlg ('El contador no se ha guardado correctamente.', mtError, [mbOK], 0);
      end;
    end;
  end;
end;

procedure TformGPaletLinea.obtenerEntrada ();
begin
  datos.TC2.Close;
  datos.tc2.SQL.Clear;
  datos.TC2.SQL.Add('SELECT ea.Codigo, ea.Matricula, ea.PesoNeto, ea.fecha, ea.Hora, pc.Nombre Parcela, cu.Nombre Cultivo');
  datos.TC2.SQL.Add('FROM ' + vtTablaEntradaAlmacen + ' ea, ' + vtTablaParcela + ' pc, ' + vtTablaCultivo + ' cu');
  datos.TC2.SQL.Add('WHERE ea.codigo = :pCodigo AND ea.CodigoParcela = pc.Codigo AND pc.CodigoCultivo = cu.Codigo');
  datos.TC2.ParamByName('pCodigo').Value := datos.tPaletDetalleCodigoEntrada.Value;
  datos.TC2.Open;
  if datos.TC2.RecordCount <= 0 then
  begin
    lInfo.Caption := '';
    MessageDlg('No existe Entrada de Almacn con el cdigo seleccionado.', mtWarning, [mbok], 0);
    txtCodigoEntrada.SetFocus;
  end
  else
  begin
    if not varisnull(datos.TC2.fieldbyname('Parcela').Value) then
      lInfo.Caption := datos.TC2.fieldbyname('Parcela').Value
    else
      lInfo.Caption := '';
    if not varisnull(datos.TC2.fieldbyname('Matricula').Value) then
      lInfo2.Caption := datos.TC2.fieldbyname('Matricula').Value
    else
      lInfo2.Caption := '';
    if not varisnull(datos.TC2.fieldbyname('Fecha').Value) then
      lInfo3.Caption := datetostr(datos.TC2.fieldbyname('Fecha').Value)
    else
      lInfo3.Caption := '';
    if not varisnull(datos.TC2.fieldbyname('Hora').Value) then
      lInfo5.Caption := timetostr(datos.TC2.fieldbyname('Hora').Value)
    else
      lInfo5.Caption := '';

    if not varisnull(datos.TC2.fieldbyname('Cultivo').Value) then
      lInfo4.Caption := datos.TC2.fieldbyname('Cultivo').Value
    else
      lInfo4.Caption := '';
    if ((datos.tPaletDetallePesoNeto.Value = 0) or
        (datos.tPaletDetallePesoNeto.Value = null)) and
        (datos.TC2.fieldbyname('PesoNeto').Value <> null) then
      datos.tPaletDetallePesoNeto.Value := datos.TC2.fieldbyname('PesoNeto').Value;
  end;
end;


procedure TformGPaletLinea.BCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TformGPaletLinea.BAceptarClick(Sender: TObject);
var
  numeroLote : Integer;
begin
  if txtNumeroLote.Text = '' then
    bObtenerLoteClick(nil);
  if txtCodigoEntrada.Text = '' then
  begin
    messagedlg ('Debe introducir un Cdigo de Entrada de Almacn.', mtinformation, [mbok], 0);
    txtCodigoEntrada.setfocus;
    exit;
  end;

  //si no existe el envase lo aadimos
  if (datos.tPaletDetalleEnvase.Value <> '') and (datos.tPaletDetalleEnvase.Value <> null) then
  begin
    datos.tEnvase.Open;
    if not datos.tEnvase.Locate('Nombre', datos.tPaletDetalleEnvase.Value, []) then
    begin
      datos.tEnvase.Insert;
      datos.tEnvaseNombre.Value := datos.tPaletDetalleEnvase.Value;
      if not varisnull(datos.tPaletDetalleEnvaseTara.Value) then
        datos.tEnvaseTara.Value := datos.tPaletDetalleEnvaseTara.Value;
      try
        datos.tEnvase.Post;
      except
      end;
    end;
  end;

  //si no existe el producto de las etiquetas lo aadimos
  if (datos.tPaletDetalleProducto.Value <> '') and (datos.tPaletDetalleProducto.Value <> null) then
  begin
    datos.tEtiquetaProducto.Open;
    if not datos.tEtiquetaProducto.Locate('Nombre', datos.tPaletDetalleProducto.Value, []) then
    begin
      datos.tEtiquetaProducto.Insert;
      datos.tEtiquetaProductoNombre.Value := datos.tPaletDetalleProducto.Value;
      try
        datos.tEtiquetaProducto.Post;
      except
      end;
    end;
  end;

  //si no existe la variedad de las etiquetas la aadimos
  if (datos.tPaletDetalleVariedad.Value <> '') and (datos.tPaletDetalleVariedad.Value <> null) then
  begin
    datos.tEtiquetaVariedad.Open;
    if not datos.tEtiquetaVariedad.Locate('Nombre', datos.tPaletDetalleVariedad.Value, []) then
    begin
      datos.tEtiquetaVariedad.Insert;
      datos.tEtiquetaVariedadNombre.Value := datos.tPaletDetalleVariedad.Value;
      try
        datos.tEtiquetaVariedad.Post;
      except
      end;
    end;
  end;

  //si no existe la categora de las etiquetas la aadimos
  if (datos.tPaletDetalleCategoria.Value <> '') and (datos.tPaletDetalleCategoria.Value <> null) then
  begin
    datos.tEtiquetaCategoria.Open;
    if not datos.tEtiquetaCategoria.Locate('Nombre', datos.tPaletDetalleCategoria.Value, []) then
    begin
      datos.tEtiquetaCategoria.Insert;
      datos.tEtiquetaCategoriaNombre.Value := datos.tPaletDetalleCategoria.Value;
      try
        datos.tEtiquetaCategoria.Post;
      except
      end;
    end;
  end;

  //si no existe el calibre de las etiquetas la aadimos
  if (datos.tPaletDetalleCalibre.Value <> '') and (datos.tPaletDetalleCalibre.Value <> null) then
  begin
    datos.tEtiquetaCalibre.Open;
    if not datos.tEtiquetaCalibre.Locate('Nombre', datos.tPaletDetalleCalibre.Value, []) then
    begin
      datos.tEtiquetaCalibre.Insert;
      datos.tEtiquetaCalibreNombre.Value := datos.tPaletDetalleCalibre.Value;
      try
        datos.tEtiquetaCalibre.Post;
      except
      end;
    end;
  end;

  //si tenemos que marcar la entrada como finalizada
  if vtMarcarEntradaFinalizada then
  begin
    datos.tEntradaAlmacen.Close;
    datos.tEntradaAlmacen.Filtered := false;
    datos.tEntradaAlmacen.Open;
    if datos.tEntradaAlmacen.Locate('Codigo', txtCodigoEntrada.Text, []) then
    begin
      datos.tEntradaAlmacen.Edit;
      datos.tEntradaAlmacenFinalizada.Value := true;
      datos.tEntradaAlmacen.Post;
    end;
  end;
  if datos.tPaletDetalle.State  in [dsinsert, dsedit] then
  begin
    //Generamos el cdigo automtico
    if (vtGCAPaletDetalle = true) and (formGPalet.Tag = 1) then //nuevo
    begin
      txtcodigo.Text := generarCodigoAuto;
      if txtCodigo.Text = '' then
      begin
        MessageDlg('El cdigo no ha podido generarse correctamente.', mtError, [mbok],0);
        exit;
      end;
      //generamos el nmero de lote
      datos.TC2.Close;
      datos.TC2.SQL.Clear;
      datos.TC2.SQL.Add('SELECT MAX (NumeroLote) as Numero FROM ' + vtTablaPaletDetalle);
      datos.TC2.open;
      if not datos.TC2.FieldByName('Numero').Value <> null then
        numeroLote := datos.TC2.FieldByName('Numero').Value + 1
      else//si es el primero poner un 1
        numeroLote := 1;
      datos.TC2.Close;
      datos.tPaletDetalleNumeroLote.Value := numeroLote;      
    end;

    try
      datos.tPaletDetalle.Post; //validar
    except
      txtCodigoEntrada.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TformGPaletLinea.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    if (datos.tPaletDetalle.State = dsedit) or
        (datos.tPaletDetalle.State = dsinsert) then
      datos.tPaletDetalle.cancel;
  except
    //silenciosa
  end;
  action := cafree;
end;

procedure TformGPaletLinea.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformGPaletLinea.FormShow(Sender: TObject);
begin
  datos.tEntradaAlmacen.Open;

  //obtenemos los envases
  datos.TC2.Close;
  datos.TC2.SQL.Clear;
  datos.TC2.SQL.Add('SELECT nombre FROM ' + vtTablaEnvase);
  datos.TC2.Open;
  if datos.TC2.RecordCount > 0 then
  begin
    while not datos.TC2.Eof do
    begin
      if not varisnull(datos.TC2.FieldByName('Nombre').Value) then
        txtTipoEnvase.Items.Add(datos.TC2.FieldByName('Nombre').Value);
      datos.TC2.Next;
    end;
  end;

  //obtenemos los productos de las etiquetas
  datos.TC2.Close;
  datos.TC2.SQL.Clear;
  datos.TC2.SQL.Add('SELECT nombre FROM ' + vtTablaEtiquetaProducto);
  datos.TC2.Open;
  if datos.TC2.RecordCount > 0 then
  begin
    while not datos.TC2.Eof do
    begin
      if not varisnull(datos.TC2.FieldByName('Nombre').Value) then
        txtProducto.Items.Add(datos.TC2.FieldByName('Nombre').Value);
      datos.TC2.Next;
    end;
  end;

  //obtenemos las variedades de las etiquetas
  datos.TC2.Close;
  datos.TC2.SQL.Clear;
  datos.TC2.SQL.Add('SELECT nombre FROM ' + vtTablaEtiquetaVariedad);
  datos.TC2.Open;
  if datos.TC2.RecordCount > 0 then
  begin
    while not datos.TC2.Eof do
    begin
      if not varisnull(datos.TC2.FieldByName('Nombre').Value) then
        txtVariedad.Items.Add(datos.TC2.FieldByName('Nombre').Value);
      datos.TC2.Next;
    end;
  end;

  //obtenemos las categoras de las etiquetas
  datos.TC2.Close;
  datos.TC2.SQL.Clear;
  datos.TC2.SQL.Add('SELECT nombre FROM ' + vtTablaEtiquetaCategoria);
  datos.TC2.Open;
  if datos.TC2.RecordCount > 0 then
  begin
    while not datos.TC2.Eof do
    begin
      if not varisnull(datos.TC2.FieldByName('Nombre').Value) then
        txtCategoria.Items.Add(datos.TC2.FieldByName('Nombre').Value);
      datos.TC2.Next;
    end;
  end;

  //obtenemos los calibres de las etiquetas
  datos.TC2.Close;
  datos.TC2.SQL.Clear;
  datos.TC2.SQL.Add('SELECT nombre FROM ' + vtTablaEtiquetaCalibre);
  datos.TC2.Open;
  if datos.TC2.RecordCount > 0 then
  begin
    while not datos.TC2.Eof do
    begin
      if not varisnull(datos.TC2.FieldByName('Nombre').Value) then
        txtCalibre.Items.Add(datos.TC2.FieldByName('Nombre').Value);
      datos.TC2.Next;
    end;
  end;


  if formGPalet.tag = 1 then //Nuevo
  begin
    caption := 'Nueva ' + ventana + '...';
    datos.tPaletDetalle.Open;
    //Si no est activado generar cdigo automtico
    if (vtGCAPaletDetalle) = false then
    begin
      txtCodigo.Visible := true;
      txtCodigo.SetFocus;
    end
    else
    begin
      lbCodigo.Visible := false;
      txtCodigo.Visible := false;
      txtCodigoEntrada.SetFocus;
    end;
    datos.tPaletDetalle.Insert;
    datos.tPaletDetalle.FieldByName('CodigoPalet').Value :=
        Datos.tPaletCodigo.Value;
    datos.tPaletDetalleFechaAlta.Value := Date;
    datos.tPaletDetalleHoraAlta.Value := Time;
    datos.tPaletDetalleCodigoUsuarioAlta.Value := vtCodigoUsuario;
    datos.tPaletDetalleCalibre.Value := vtEtiquetaCalibre;
    datos.tPaletDetalleProducto.Value := vtEtiquetaProducto;
    datos.tPaletDetalleVariedad.Value := vtEtiquetaVariedad;
    datos.tPaletDetalleEnvase.Value := vtEtiquetaTipoEnvase;
    datos.tPaletDetalleEnvaseTara.Value := vtEtiquetaTara;
    datos.tPaletDetalleCategoria.Value := vtEtiquetaCategoria;
  end;

  if formGPalet.tag = 2 then //Modificar
  begin
    TxtCodigo.Enabled := false;
    txtCodigo.Visible := true;
    BSeleccionarProducto.Enabled := true;
    datos.tPaletDetalle.edit;
    txtCodigoEntrada.SetFocus;
    caption := 'Modificacin de ' + ventana + '...';
    obtenerEntrada;
  end;
  if formGPalet.tag = 3 then //zoom
  begin
    TxtCodigo.Enabled := false;
    txtCodigo.Visible := true;
    BAceptar.Visible := false;
    BSeleccionarProducto.Enabled := false;
    caption := 'Visualizar de ' + ventana + '...';
  end;
end;

procedure TformGPaletLinea.txtCodigoEntradaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if formGPalet.Tag <> 3 then //zoom
  begin
    if key = '+' then
    begin
      key := chr(0);
      BSeleccionarProductoClick(nil);
    end;
  end;
end;

procedure TformGPaletLinea.BSeleccionarProductoClick(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.ActNuevo.Enabled := true;
  formseleccion.tag := vtNumEntradaAlmacen;
  formseleccion.ShowModal;
  if vtClaveElegida <> '' then
    txtCodigoEntrada.Text := vtClaveElegida;
end;

procedure TformGPaletLinea.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //teclas de cursor para cambiar el foco
  if (Key in [VK_UP, VK_DOWN]) and
      Not (ActiveControl is TDBComboBox) and not (activecontrol is tdbmemo) then
  begin
    if Key = VK_UP then
      Perform(WM_NEXTDLGCTL, 1, 0)
    else
      Perform(WM_NEXTDLGCTL, 0, 0);
    Key := 0;
  end;
end;

procedure TformGPaletLinea.txtCodigoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtCodigoEntradaEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtPesoNetoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtConceptoEnter(Sender: TObject);
begin
  TDBMemo(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtCaldoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtFechaEnter(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtCodigoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGPaletLinea.txtPesoNetoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGPaletLinea.txtConceptoExit(Sender: TObject);
begin
  TDBMemo(sender).Color := clWindow;
end;

procedure TformGPaletLinea.txtCaldoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGPaletLinea.txtFechaExit(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clWindow;
end;

procedure TformGPaletLinea.txtCodigoEntradaExit(Sender: TObject);
var
  codigo : string;
  i : integer;
begin
  TEdit(sender).Color := clWindow;
  codigo := txtCodigoEntrada.Text;
  if Length(codigo) < 8 then
  begin
    for i := 1 to 6 - length(codigo) do
      codigo := '0' + codigo;
    datos.tPaletDetalleCodigoEntrada.Value := codigo;
  end;
  obtenerEntrada;
end;

procedure TformGPaletLinea.txtPlazoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtPlazoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGPaletLinea.txtFechaDisposicionEnter(
  Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtFechaDisposicionExit(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clWindow;
end;

procedure TformGPaletLinea.txtOperacionEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtOperacionExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGPaletLinea.txtPesoNetoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGPaletLinea.txtTaraEnvaseExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;  
end;

procedure TformGPaletLinea.txtTaraEnvaseEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtTipoEnvaseExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGPaletLinea.txtTipoEnvaseEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtNumeroEnvasesEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtNumeroEnvasesExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGPaletLinea.bCalcularPNClick(Sender: TObject);
var
  numEnvases, tara : double;
begin
  if not VarIsNull(datos.tPaletDetalleNumeroEnvases.Value) then
    numEnvases := datos.tPaletDetalleNumeroEnvases.Value
  else
    numEnvases := 0;
  if not VarIsNull(datos.tPaletDetalleEnvaseTara.Value) then
    tara := datos.tPaletDetalleEnvaseTara.Value
  else
    tara := 0;
  datos.tPaletDetallePesoNeto.Value := tara * numEnvases;
end;

procedure TformGPaletLinea.txtProductoEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtVariedadEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtCalibreEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtCategoriaEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGPaletLinea.txtProductoExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGPaletLinea.txtVariedadExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGPaletLinea.txtCalibreExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGPaletLinea.txtCategoriaExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGPaletLinea.bObtenerLoteClick(Sender: TObject);
{var
  teDia, teAno, teMes, valorAMostrar : string;
  ano, mes, dia : Word;}
begin
{  DecodeDate(datos.tPaletFechaEnvasado.Value, ano, mes, dia);
  teDia := IntToStr(dia);
  teAno := IntToStr(ano);
  teMes := IntToStr(mes);
  if Length(teDia) < 2 then
    teDia := '0' + teDia;
  if Length(teMes) < 2 then
    teMes := '0' + teMes;
  valorAMostrar := teDia + teMes + copy(Datos.tPaletCodigo.Value, 2, length(Datos.tPaletCodigo.Value)) + '0';
  datos.tPaletDetalleNumeroLote.value := valorAMostrar;} 
end;

end.
