unit UnidadGParcela;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, Mask, forms, ComCtrls,
  variants, windows, dxCntner, dxEditor, dxExEdtr, dxEdLib, dxDBELib;

type
  TformGParcela = class(TForm)
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    lCodigo: TLabel;
    txtCodigo: TDBEdit;
    BGCodigoAuto: TSpeedButton;
    txtNombre: TDBEdit;
    Label1: TLabel;
    txtCodigoCultivo: TDBEdit;
    bSeleccionarCultivo: TSpeedButton;
    txtCultivo: TDBText;
    Label15: TLabel;
    bSeleccionarAgricultor: TSpeedButton;
    txtAgricultor: TDBText;
    Label2: TLabel;
    txtCodigoAgricultor: TDBEdit;
    txtSuperficie: TDBEdit;
    Label3: TLabel;
    txtFechaPlantacion: TdxDBDateEdit;
    Label4: TLabel;
    txtUbicacion: TDBEdit;
    Label5: TLabel;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure TxtCPChange(Sender: TObject);
    procedure TxtTelefonoChange(Sender: TObject);
    procedure DBEdit3KeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    function generarCodigoAuto () : string;
    function cDuplicado (nombre : string) : boolean;

    procedure BGCodigoAutoClick(Sender: TObject);
    procedure txtCodigoExit(Sender: TObject);
    procedure txtCodigoCultivoExit(Sender: TObject);
    procedure bSeleccionarCultivoClick(Sender: TObject);
    procedure txtCodigoCultivoKeyPress(Sender: TObject; var Key: Char);
    procedure txtNombreExit(Sender: TObject);
    procedure txtCodigoEnter(Sender: TObject);
    procedure txtNombreEnter(Sender: TObject);
    procedure txtCodigoCultivoEnter(Sender: TObject);
    procedure bSeleccionarAgricultorClick(Sender: TObject);
    procedure txtCodigoAgricultorEnter(Sender: TObject);
    procedure txtCodigoAgricultorExit(Sender: TObject);
    procedure txtCodigoAgricultorKeyPress(Sender: TObject; var Key: Char);
    procedure txtSuperficieEnter(Sender: TObject);
    procedure txtUbicacionEnter(Sender: TObject);
    procedure txtFechaPlantacionEnter(Sender: TObject);
    procedure txtSuperficieExit(Sender: TObject);
    procedure txtUbicacionExit(Sender: TObject);
    procedure txtFechaPlantacionExit(Sender: TObject);
    procedure txtSuperficieKeyPress(Sender: TObject; var Key: Char);

  private
    accionTemp : string;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formGParcela: TformGParcela;
const
  ventana = 'Parcela';
  ventanas = 'Parcelas';

implementation


uses UnidadModuloDatos, UnidadProcedimientos, UnidadSeleccion,
  UnidadGAgricultor;

var
  tTabla : TTable;
  valorAnterior : string; //para modificacin de Nombre
{$R *.DFM}

//Genera el cdigo automticamente
function TformGParcela.generarCodigoAuto () : string;
var
  vano, vmes, vdia : word;
  contador : double;
begin
  DecodeDate(date, vano, vmes, vdia);
  with datos.tc do
  begin
    Close;
    SQL.Clear;  //obtenemos el contador de la tabla contadores
    SQL.Add('SELECT Contador');
    SQL.Add('FROM ' + vtTablaContador);
    SQL.Add('WHERE tabla = :pTabla');
    //SQL.Add('WHERE tabla = :pTabla AND anio = :pAno');
    //ParamByName('pAno').DataType := ftFloat;
    //ParamByName('pAno').Value := vano;
    ParamByName('pTabla').DataType := ftString;
    ParamByName('pTabla').Value := vtTablaParcela;
    Open;
    if FieldByName('Contador').value <> null then
    begin
      try
        contador := FieldByName('Contador').Value + 1;
        generarCodigoAuto := llenarCadena(floattostr(contador),4,'0', false);
        //Incrementamos el contador de la tabla contadores
        Close;
        SQL.Clear;
        SQL.Add('UPDATE ' + vtTablaContador +
            ' SET Contador = :pContador, CodigoUsuarioAlta = "'
            + vtCodigoUsuario + '" WHERE tabla = :pTabla');
             //+ vtCodigoUsuario + '" WHERE tabla = :pTabla AND anio = :pAno');
        //ParamByName('pAno').DataType := ftFloat;
        //ParamByName('pAno').Value := vano;
        ParamByName('pContador').DataType := ftFloat;
        ParamByName('pContador').Value := contador;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').Value := vtTablaParcela;
        ExecSQL;
        close;
      except
        Close;
        generarCodigoAuto := '0';
        MessageDlg ('El cdigo no ha podido generarse automticamente.', mtError, [mbOK], 0);
        txtCodigo.Enabled := true;
        txtCodigo.Visible := true;
        txtCodigo.SetFocus;
      end;
    end
    else  //si no existe el registro de contador para la tabla actual, lo creamos
    begin
      try
        Close;
        SQL.Clear;
        SQL.Add('INSERT INTO ' + vtTablaContador +
            ' (Anio, Tabla, Contador, Nota, Activo, CodigoUsuarioAlta) ' +
            ' VALUES (:pAno, :pTabla, 1, "Aadido automticamente", True, "' + vtCodigoUsuario + '")');
        ParamByName('pAno').DataType := ftFloat;
        ParamByName('pAno').Value := vano;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').Value := vtTablaParcela;
        ExecSQL;
        generarCodigoAuto := '0001';
        Close;
      except
        Close;
        MessageDlg ('El contador no se ha guardado correctamente.', mtError, [mbOK], 0);
      end;
    end;
  end;
end;

//comprobar nombre duplicado
function TformGParcela.cDuplicado (nombre : string) : boolean;
begin
  with datos.tc do
  begin
    Close;
    SQL.Clear;
    SQL.Add('SELECT COUNT(Codigo) Contador');
    SQL.Add('FROM ' + vtTablaParcela);
    SQL.Add('WHERE UPPER(nombre) = :pNombre');
    ParamByName('pNombre').DataType := ftString;
    ParamByName('pNombre').Value := AnsiUpperCase(nombre);
    Open;
    if FieldByName('Contador').value > 0 then
    begin
      Close;
      cDuplicado := true;
    end
    else
    begin
      Close;
      cDuplicado := false;
    end;
  end;
end;


procedure TformGParcela.BCancelarClick(Sender: TObject);
begin
  try
    ttabla.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TformGParcela.BAceptarClick(Sender: TObject);
begin
  //si el cdigo no se genera automticamente comprobar que est introducido
  if txtCodigo.Visible then
  begin
    if txtCodigo.Text = '' then
    begin
      MessageDlg ('El campo Cdigo debe tener un valor', mtWarning, [mbok], 0);
      TxtCodigo.setfocus;
      exit;
    end;
  end;
  if txtNombre.Text = '' then
  begin
    MessageDlg ('El campo Nombre debe tener un valor', mtWarning, [mbok], 0);
    TxtNombre.setfocus;
    exit;
  end;
  //si es una modificacin y se modifica el nombre, comprobar duplicidad
  if vtAccion = 'modificar' then
  begin
    if AnsiUpperCase(txtNombre.Text) <> AnsiUpperCase(valorAnterior) then //s se ha modificado
    begin
      if cDuplicado(txtNombre.Text) then
      begin
        MessageDlg('La ' + ventana + ' [' + txtNombre.Text + '] ya existe.', mtWarning, [mbok], 0);
        txtNombre.SelectAll;
        txtnombre.SetFocus;
        exit;
      end;
    end;
  end;
  //si es nuevo comprobar duplicidad
  if vtAccion = 'nuevo' then
  begin
    if cDuplicado(txtNombre.Text) then
    begin
      MessageDlg('La ' + ventana + ' [' + txtNombre.Text + '] ya existe.', mtWarning, [mbok], 0);
      txtNombre.SelectAll;
      txtnombre.SetFocus;
      exit;
    end;
  end;
  if txtCultivo.Caption = '' then
  begin
    MessageDlg ('El cultivo introducido no existe, seleccione otro.', mtWarning, [mbok], 0);
    txtCodigoCultivo.setfocus;
    exit;
  end;
  if txtAgricultor.Caption = '' then
  begin
    MessageDlg ('El agricultor introducido no existe, seleccione otro.', mtWarning, [mbok], 0);
    txtCodigoAgricultor.setfocus;
    exit;
  end;

  if ttabla.State  in [dsinsert, dsedit] then
  begin
    //Generar cdigo automticamente si es una insercin
    if (vtGCAParcela = true) and (vtAccion = 'nuevo') then
      txtcodigo.Text := generarCodigoAuto;
    tTabla.FieldByName('CodigoUsuarioAlta').Value := vtCodigoUsuario;
    tTabla.FieldByName('FechaAlta').Value := Date;
    tTabla.FieldByName('HoraAlta').Value := Time;
    try
      ttabla.Post; //validar
    except
      txtNombre.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TformGParcela.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  vtCodigoTemporal := '';
  vtCodigoTemporal2 := '';
  ttabla.Close;
  action := cafree;
end;

procedure TformGParcela.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformGParcela.FormShow(Sender: TObject);
begin
  tTabla := datos.tParcela;
  datos.tAgricultor.Open;
  datos.tCultivo.Open;
  if vtAccion = 'nuevo' then
  begin
    caption := 'Aadir ' + ventana + '...';
    bSeleccionarCultivo.Visible := true;
    bSeleccionarAgricultor.Visible := true;
    //Si no est activado generar cdigo automtico
    if (vtGCAParcela) = false then
    begin
      txtCodigo.Visible := true;
      txtCodigo.SetFocus;
      BGCodigoAuto.Visible := true;
    end
    else
      txtNombre.SetFocus;
    tTabla.Active := true;
    tTabla.Insert;
    if vtCodigoTemporal <> '' then
      ttabla.fieldbyname('CodigoAgricultor').Value := vtCodigoTemporal;
    if vtCodigoTemporal2 <> '' then
      ttabla.fieldbyname('Nombre').Value := vtCodigoTemporal2;
    ttabla.fieldbyname('FechaPlantacion').Value := date;
  end;

  if vtAccion = 'modificar' then
  begin
    bSeleccionarCultivo.Visible := true;
    bSeleccionarAgricultor.Visible := true;
    txtcodigo.Enabled := false;
    BGCodigoAuto.Enabled := false;
    caption := 'Modificacin de ' + ventana + '...';
    txtNombre.SetFocus;
    valorAnterior := ttabla.fieldbyname('Nombre').Value;
    tTabla.Edit;
  end;

  if vtAccion = 'zoom' then
  begin
    tTabla.Active := true;
    tTabla.locate ('Codigo', vtCodigo, []);
    caption := 'Visualizacin de ' + ventana + '...';
    txtcodigo.Enabled := false;
    BGCodigoAuto.Enabled := false;
    txtNombre.Enabled := false;
    baceptar.Visible := false;
    bcancelar.SetFocus;
  end;
end;

procedure TformGParcela.TxtCPChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txtcp.text) = 5 then
      txttelefono.setfocus;
  end;}
end;

procedure TformGParcela.TxtTelefonoChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txttelefono.text) = 9 then
      opIVA.setfocus;
  end;}
end;

procedure TformGParcela.DBEdit3KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = '.' then
    key := ',';
end;

procedure TformGParcela.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //cambiar el foco con las teclas de cursor
  if (Key in [VK_UP, VK_DOWN]) and
      Not (ActiveControl is TDBComboBox) and not (ActiveControl is TDBMemo) then
  begin
    if Key = VK_UP then
      Perform(WM_NEXTDLGCTL, 1, 0)
    else
      Perform(WM_NEXTDLGCTL, 0, 0);
    Key := 0;
  end;
end;

procedure TformGParcela.BGCodigoAutoClick(Sender: TObject);
begin
  txtCodigo.Text := generarCodigoAuto;
end;

procedure TformGParcela.txtCodigoExit(Sender: TObject);
var
  i : integer;
  codigo : string;
begin
  TEdit(sender).Color := clWindow;
  codigo := txtCodigo.Text;
  if Length(codigo) < 4 then
  begin
    for i := 1 to 4 -length(codigo) do
      codigo := '0' + codigo;
    datos.tParcelaCodigo.Value := codigo;
  end;
end;

procedure TformGParcela.txtCodigoCultivoExit(Sender: TObject);
var
  i : integer;
  codigo : string;
begin
  TEdit(sender).Color := clWindow;
  codigo := txtCodigoCultivo.Text;
  if Length(codigo) < 4 then
  begin
    for i := 1 to 4 -length(codigo) do
      codigo := '0' + codigo;
    datos.tParcelaCodigoCultivo.Value := codigo;
  end;
  datos.TC2.Close;
  datos.tc2.SQL.Clear;
  datos.TC2.SQL.Add('SELECT Codigo, Nombre FROM ' + vtTablaCultivo +
      ' WHERE codigo = :pCodigo');
  datos.TC2.ParamByName('pCodigo').Value := tTabla.fieldbyname('CodigoCultivo').Value;
  datos.TC2.Open;
  if datos.TC2.RecordCount > 0 then
    txtCultivo.Caption := datos.TC2.fieldbyname('Nombre').value;
end;

procedure TformGParcela.bSeleccionarCultivoClick(Sender: TObject);
begin
  accionTemp := vtAccion; 
  if (vtAccion = 'nuevo') or (vtAccion = 'modificar') then
  begin
    txtCodigoCultivo.setfocus;
    application.createform(tformseleccion, formseleccion);
    formseleccion.tag := vtNumCultivo;
    formseleccion.ShowModal;
    if vtClaveElegida <> '' then
    begin
      if vtClaveElegida <> '' then
      begin
        txtCodigoCultivo.Text := vtClaveElegida;
        Perform(WM_NEXTDLGCTL, 0, 0);
      end;
    end;
  end;
  vtAccion := accionTemp;
end;

procedure TformGParcela.txtCodigoCultivoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (key = '+') and (bSeleccionarCultivo.Enabled) then
  begin
    key := chr(0);
    bSeleccionarCultivoClick(nil);
 end;
end;

procedure TformGParcela.txtNombreExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGParcela.txtCodigoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGParcela.txtNombreEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGParcela.txtCodigoCultivoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGParcela.bSeleccionarAgricultorClick(Sender: TObject);
begin
  accionTemp := vtAccion; 
  if (vtAccion = 'nuevo') or (vtAccion = 'modificar') then
  begin
    txtCodigoAgricultor.setfocus;
    application.createform(tformseleccion, formseleccion);
    formseleccion.tag := vtNumAgricultor;
    formseleccion.ShowModal;
    if vtClaveElegida <> '' then
    begin
      if vtClaveElegida <> '' then
      begin
        txtCodigoAgricultor.Text := vtClaveElegida;
        Perform(WM_NEXTDLGCTL, 0, 0);
      end;
    end;
  end;
  vtAccion := accionTemp;
end;

procedure TformGParcela.txtCodigoAgricultorEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGParcela.txtCodigoAgricultorExit(Sender: TObject);
var
  i : integer;
  codigo : string;
begin
  TEdit(sender).Color := clWindow;
  codigo := txtCodigoAgricultor.Text;
  if Length(codigo) < vtTamProveedor then
  begin
    for i := 1 to vtTamProveedor - length(codigo) do
      codigo := '0' + codigo;
    datos.tParcelaCodigoAgricultor.Value := codigo;
  end;
  datos.TC2.Close;
  datos.tc2.SQL.Clear;
  datos.TC2.SQL.Add('SELECT Codigo, Nombre FROM ' + vtTablaAgricultor +
      ' WHERE codigo = :pCodigo');
  datos.TC2.ParamByName('pCodigo').Value := tTabla.fieldbyname('CodigoAgricultor').Value;
  datos.TC2.Open;
  if datos.TC2.RecordCount > 0 then
    txtAgricultor.Caption := datos.TC2.fieldbyname('Nombre').value;
end;

procedure TformGParcela.txtCodigoAgricultorKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (key = '+') and (bSeleccionarAgricultor.Enabled) then
  begin
    key := chr(0);
    bSeleccionarAgricultorClick(nil);
 end;
end;

procedure TformGParcela.txtSuperficieEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGParcela.txtUbicacionEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGParcela.txtFechaPlantacionEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGParcela.txtSuperficieExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGParcela.txtUbicacionExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGParcela.txtFechaPlantacionExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGParcela.txtSuperficieKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

end.
