unit UnidadInformacionLote;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, DB, dxExEdtr, dxDBTLCl, dxGrClms,
  dxTL, dxDBCtrl, dxDBGrid, dxCntner;

type
  TformInformacionLote = class(TForm)
    Panel1: TPanel;
    txtLote: TComboBox;
    Label1: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    lNumeroPalet: TLabel;
    lFecha: TLabel;
    Label4: TLabel;
    lHora: TLabel;
    Label3: TLabel;
    lCliente: TLabel;
    Label5: TLabel;
    bConsultar: TButton;
    TabSheet3: TTabSheet;
    txtDatosCopiar: TMemo;
    Panel2: TPanel;
    GroupBox2: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    lProveedor: TLabel;
    lParcela: TLabel;
    TabSheet2: TTabSheet;
    Tabla: TdxDBGrid;
    TablaCodigo: TdxDBGridMaskColumn;
    TablaFecha: TdxDBGridDateColumn;
    TablaProducto: TdxDBGridMaskColumn;
    TablaOperacion: TdxDBGridMaskColumn;
    TablaDosis: TdxDBGridMaskColumn;
    TablaUnidadDosis: TdxDBGridMaskColumn;
    TablaGastoCaldo: TdxDBGridMaskColumn;
    TablaGastoCaldoUnidad: TdxDBGridMaskColumn;
    TablaPlazoSeguridad: TdxDBGridMaskColumn;
    TablaFechaDisposicion: TdxDBGridDateColumn;
    TablaCodigoFichaControl: TdxDBGridMaskColumn;
    TablaCodigoProducto: TdxDBGridMaskColumn;
    TablaCodigoUsuarioAlta: TdxDBGridMaskColumn;
    TablaFechaAlta: TdxDBGridDateColumn;
    TablaHoraAlta: TdxDBGridTimeColumn;
    procedure bConsultarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formInformacionLote: TformInformacionLote;

implementation

uses UnidadModuloDatos, UnidadProcedimientos;

{$R *.dfm}

procedure TformInformacionLote.bConsultarClick(Sender: TObject);
var
  numLote : Double;
  codigoParcela, numLoteStr : string;
begin
  txtDatosCopiar.Clear;
  numLoteStr := txtLote.text;
  if length(numLoteStr) = 13 then //suponemos que se ha insertado el cdigo de barras
    numLoteStr := copy (numLoteStr, 5, 8); 
  try
    numLote := StrToFloat(numLoteStr);
  except
    MessageDlg('El nmero de lote introducido no es correcto, introduzca slo nmeros.',
        mtInformation, [mbok], 0);
    exit;
  end;

  with datos.tcConsultaLote do
  begin
    Close;
    SQL.Clear;
    SQL.Add('SELECT p.Codigo, p.FechaEnvasado, p.HoraEnvasado, ');
    SQL.Add('    c.Nombre Cliente, a.Nombre Agricultor, pa.Codigo CodigoParcela, ');
    SQL.Add('    pa.Nombre Parcela, e.Codigo CodigoEntrada');
    SQL.Add('FROM ' + vtTablaPaletDetalle + ' pd, ' + vtTablaCliente + ' c,' +
        vtTablaPalet + ' p, ' + vtTablaEntradaAlmacen + ' e, ' +
        vtTablaParcela + ' pa, ' + vtTablaAgricultor + ' a');
    SQL.Add('WHERE pd.NumeroLote = :pNumLote AND p.CodigoCliente = c.Codigo ');
    SQL.Add('    AND p.Codigo = pd.CodigoPalet AND e.Codigo = pd.CodigoEntrada');
    SQL.Add('    AND e.CodigoParcela = pa.Codigo AND pa.CodigoAgricultor = a.Codigo');
    ParamByName('pNumLote').DataType := ftFloat;
    ParamByName('pNumLote').Value := numLote;
    Open;
    if RecordCount > 0 then
    begin
      lNumeroPalet.Caption := fieldbyname('Codigo').AsString;
      txtDatosCopiar.Lines.Add ('N Palet: ' + fieldbyname('Codigo').AsString);
      lFecha.Caption := fieldbyname('FechaEnvasado').AsString;
      txtDatosCopiar.Lines.Add ('Fecha envasado: ' + fieldbyname('FechaEnvasado').AsString);
      lHora.Caption := fieldbyname('HoraEnvasado').AsString;
      txtDatosCopiar.Lines.Add ('Hora envasado: ' + fieldbyname('HoraEnvasado').AsString);
      lCliente.Caption := fieldbyname('Cliente').AsString;
      txtDatosCopiar.Lines.Add ('Cliente: ' + fieldbyname('Cliente').AsString);
      lParcela.Caption := fieldbyname('Parcela').AsString;
      txtDatosCopiar.Lines.Add ('Parcela: ' + fieldbyname('Parcela').AsString);
      lProveedor.Caption := fieldbyname('Agricultor').AsString;
      txtDatosCopiar.Lines.Add ('Proveedor: ' + fieldbyname('Agricultor').AsString);

      //obtenemos las fichas de control de la parcela a la que corresponde el nmero de lote
      codigoParcela := fieldbyname('CodigoParcela').AsString;
      Close;
      SQL.Clear;
      SQL.Add('SELECT fd.*, p.Nombre Producto');
      SQL.Add('FROM ' + vtTablaFichaControl + ' f, ' +
          vtTablaFichaControlDetalle + ' fd, ' + vtTablaProducto + ' p');
      SQL.Add('WHERE f.CodigoParcela = :pCodigoParcela AND fd.CodigoFichaControl = f.Codigo');
      SQL.Add('  AND fd.CodigoProducto = p.codigo'); 
      ParamByName('pCodigoParcela').DataType := ftString;
      ParamByName('pCodigoParcela').Value := codigoParcela;
      Open;
      Tabla.KeyField := 'Codigo';
      Tabla.DataSource := datos.dTCConsultaLote;
      tabla.Refresh; 

    end
    else
    begin
      MessageDlg('El nmero de Lote introducido no existe.', mtInformation, [mbok], 0);
      datos.tcConsultaLote.Close;
      txtLote.SetFocus;
    end;
  end;
end;

procedure TformInformacionLote.FormCreate(Sender: TObject);
var
  numLote : string;
  i : integer;
begin
  datos.tc.Close;
  datos.tc.SQL.Clear;
  datos.tc.SQL.Add('SELECT distinct(NumeroLote) FROM ' + vtTablaPaletDetalle);
  datos.tc.Open;
  while not datos.tc.Eof do
  begin
    numLote := datos.tc.FieldByName('NumeroLote').AsString;
    for i := 0 to 11 - length(numLote) do
      numLote := '0' + numLote;
    txtLote.Items.Add (numLote);
    datos.tc.Next;
  end;
end;

procedure TformInformacionLote.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  datos.tcConsultaLote.Close;
  action := caFree;
end;

procedure TformInformacionLote.FormShow(Sender: TObject);
begin
  screen.cursor := crDefault;
end;

end.
