unit UnidadPalet;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, variants, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, dxExEdtr, dxDBTLCl, dxGrClms, dxgridmenus;

type
  TformPalet = class(TForm)
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton9: TToolButton;
    Tabla: TdxDBGrid;
    actOP: TActionList;
    actEnviarExcel: TAction;
    actMostrarOcultarAutofiltros: TAction;
    actEnviarTodosTexto: TAction;
    actMostrarOcultarSumario: TAction;
    actMostrarOcultarPanelAgrupacion: TAction;
    actEnviarTodosXML: TAction;
    actEnviarHTML: TAction;
    actEnviarPortaPapeles: TAction;
    pmEnvio: TPopupMenu;
    EnviartodosaExcel1: TMenuItem;
    EnviartodosaTexto1: TMenuItem;
    EnviartodosaHTML1: TMenuItem;
    EnviartodosaXML1: TMenuItem;
    N4: TMenuItem;
    Copiaralportapapeles1: TMenuItem;
    dlGuardar: TSaveDialog;
    ActionList1: TActionList;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ActRefrescar: TAction;
    ActCerrar: TAction;
    ActImprimir: TAction;
    ActVisualizar: TAction;
    tc: TQuery;
    dTC: TDataSource;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    tcCodigo: TStringField;
    tcCodigoCliente: TStringField;
    tcFechaEnvasado: TDateField;
    tcHoraEnvasado: TTimeField;
    tcCodigoUsuarioAlta: TStringField;
    tcFechaAlta: TDateField;
    tcHoraAlta: TTimeField;
    tcCliente: TStringField;
    TablaCodigo: TdxDBGridMaskColumn;
    TablaCodigoCliente: TdxDBGridMaskColumn;
    TablaFechaEnvasado: TdxDBGridDateColumn;
    TablaHoraEnvasado: TdxDBGridTimeColumn;
    TablaCodigoUsuarioAlta: TdxDBGridMaskColumn;
    TablaFechaAlta: TdxDBGridDateColumn;
    TablaHoraAlta: TdxDBGridTimeColumn;
    TablaCliente: TdxDBGridMaskColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActVisualizarExecute(Sender: TObject);
    procedure actEnviarExcelExecute(Sender: TObject);
    procedure actEnviarHTMLExecute(Sender: TObject);
    procedure actEnviarPortaPapelesExecute(Sender: TObject);
    procedure actEnviarTodosTextoExecute(Sender: TObject);
    procedure actEnviarTodosXMLExecute(Sender: TObject);
    procedure actMostrarOcultarAutofiltrosExecute(Sender: TObject);
    procedure actMostrarOcultarPanelAgrupacionExecute(Sender: TObject);
    procedure actMostrarOcultarSumarioExecute(Sender: TObject);
    procedure TablaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure llenarGrid();


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formPalet: TformPalet;
const
  ventana = 'Palet';
  ventanas = 'Palets';

implementation

uses UnidadMenuPrincipal, UnidadImprimir, UnidadModuloDatos,
  UnidadProcedimientos, UnidadGPalet;
{$R *.DFM}

var
  tTabla : TTable;

procedure TformPalet.llenarGrid();
begin
  tc.Close;
  tc.SQL.Clear;
  tc.SQL.Add('SELECT pa.*, cl.Nombre Cliente');
  tc.SQL.Add('FROM ' + vtTablaPalet + ' pa, ' + vtTablaCliente + ' cl');
  tc.SQL.Add('WHERE pa.CodigoCliente = cl.Codigo');
  tc.Open;
end;

  
procedure TformPalet.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
   tc.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TformPalet.FormShow(Sender: TObject);
begin
  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
  screen.cursor := crdefault;
end;

procedure TformPalet.ActNuevoExecute(Sender: TObject);
begin
  if comprobarPermisos ('altas', vtTipoUsuario, vtTablaPalet) then
  begin
    vtAccion := 'nuevo';
    application.createform(TformGPalet, formGPalet);
    formGPalet.ShowModal;
    ActRefrescarExecute(nil);
  end;
end;

procedure TformPalet.ActEliminarExecute(Sender: TObject);
var
  nombre : string;
begin
  if tc.RecordCount <= 0 then
    MessageDlg ('No hay datos para eliminar.', mtWarning, [mbok], 0)
  else
  begin
    if comprobarPermisos('bajas', vtTipoUsuario, vtTablaPalet) then
    begin
      tTabla.Active := true;
      if tTabla.locate('Codigo',
          tcCodigo.value, []) then
      begin
        if not varisnull(tcCodigo.Value) then
          nombre := tcCodigo.Value
        else
          nombre := null;
        if messagedlg ('Est seguro que desea eliminar el ' + ventana + ': ' +
            nombre + '?', mtConfirmation, [mbyes, mbno], 0) = mryes then
        begin
          try
            datos.tc.Close;
            datos.tc.sql.clear;
            datos.tc.SQL.add('DELETE FROM ' + vtTablaPaletDetalle +
                ' WHERE CodigoPalet = :pCodigo');
            datos.tc.ParamByName('pCodigo').DataType := ftString;
            datos.tc.ParamByName('pCodigo').Value := tcCodigo.Value;
            datos.tc.ExecSQL;
            ttabla.Delete;
            ActRefrescarExecute(nil);
          except
            raise;
          end;
        end;
      end;
    end;
  end;
end;

procedure TformPalet.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TformPalet.ActModificarExecute(Sender: TObject);
begin
  if tc.RecordCount <= 0 then
    messagedlg ('No hay datos para modificar.', mtInformation, [mbok], 0)
  else
  begin
    if comprobarPermisos ('modificacin', vtTipoUsuario, vtTablaPalet) then
    begin
      if not varisnull(tcCodigo.value) then
      begin
        vtAccion := 'modificar';
        ttabla.Active := true;
        ttabla.locate ('Codigo', tcCodigo.Value, []);
        ttabla.edit;
        application.createform(TformGPalet, formGPalet);
        formGPalet.ShowModal;
        ActRefrescarExecute(nil);
      end
      else
        messagedlg ('Atencin, el ' + ventana + ' actual no tiene cdigo, ' +
            'elimnelo antes de continuar.', mtError, [mbok], 0);
    end;
  end;
end;

procedure TformPalet.TablaDblClick(Sender: TObject);
begin
  if ActModificar.Enabled = true then
    ActModificarExecute(nil);
end;

procedure TformPalet.ActRefrescarExecute(Sender: TObject);
begin
  llenarGrid;
end;

procedure TformPalet.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TformPalet.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TformPalet.ActImprimirExecute(Sender: TObject);
begin
  if tc.RecordCount <= 0 then
    messagedlg ('No hay datos para imprimir.', mtInformation, [mbok], 0)
  else
  begin
    if comprobarPermisos ('imprimir', vtTipoUsuario, vtTablaPalet) then
    begin
      application.createform(tformImprimir, formImprimir);
      formimprimir.Tag := vtNumPalet;
      formImprimir.showmodal;
    end;
  end;
end;

procedure TformPalet.ActVisualizarExecute(Sender: TObject);
begin
  if tc.RecordCount <= 0 then
    messagedlg ('No hay datos para mostrar.', mtInformation, [mbok], 0)
  else
  begin
    if comprobarPermisos ('zoom', vtTipoUsuario, vtTablaPalet) then
    begin
      vtAccion := 'zoom';
      vtCodigo := tcCodigo.value;
      application.createform(TformGPalet, formGPalet);
      formGPalet.ShowModal;
    end;
  end;
end;

procedure TformPalet.actEnviarExcelExecute(Sender: TObject);
begin
  if tc.RecordCount <= 0 then
    MessageDlg ('No hay datos para exportar.', mtWarning, [mbok], 0)
  else
  begin
    dlguardar.Filter := 'Ficheros Excel (*.xls)|*.xls|Todos los ficheros|*.*';
    dlguardar.Title := 'Exportar ' + ventanas + ' a Excel';
    dlGuardar.DefaultExt := 'xls';
    dlguardar.FileName := ventanas;
    if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
      createdir (extractfilepath(application.ExeName) + 'Exportados');
    dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
    if dlGuardar.execute then
    begin
      tabla.SaveToXLS(dlguardar.FileName,true);
      MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
    end;
  end;
end;

procedure TformPalet.actEnviarHTMLExecute(Sender: TObject);
begin
  if tc.RecordCount <= 0 then
    MessageDlg ('No hay datos para exportar.', mtWarning, [mbok], 0)
  else
  begin
    dlguardar.Filter := 'Ficheros HTML (*.html)|*.html|Ficheros HTML (*.htm)|*.htm|Todos los ficheros|*.*';
    dlguardar.Title := 'Exportar ' + ventanas + ' a HTML';
    dlGuardar.DefaultExt := 'html';
    dlguardar.FileName := ventanas;
    if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
      createdir (extractfilepath(application.ExeName) + 'Exportados');
    dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
    if dlGuardar.execute then
    begin
      tabla.SaveToHTML(dlguardar.filename, true);
      MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
    end;
  end;
end;


procedure TformPalet.actEnviarPortaPapelesExecute(Sender: TObject);
begin
  if tc.RecordCount <= 0 then
    MessageDlg ('No hay datos para exportar.', mtWarning, [mbok], 0)
  else
  begin
    tabla.CopyAllToClipboard;
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;

procedure TformPalet.actEnviarTodosTextoExecute(Sender: TObject);
var
  separador : string;
begin
  if tc.RecordCount <= 0 then
    MessageDlg ('No hay datos para exportar.', mtWarning, [mbok], 0)
  else
  begin
    dlguardar.Filter := 'Ficheros de texto (*.txt)|*.txt|Ficheros Word (*.doc)|*.doc|Todos los ficheros|*.*';
    dlguardar.Title := 'Exportar ' + ventanas + ' a texto sin formato';
    dlguardar.FileName := ventanas;
    dlGuardar.DefaultExt := 'txt';
    if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
      createdir (extractfilepath(application.ExeName) + 'Exportados');
    dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
    if dlGuardar.execute then
    begin
      separador := InputBox('Separador para campos...', 'Introduzca un carcter que ser el separador de campos:', '#');
      if Length(separador) > 1 then
        MessageDlg('Slo debe seleccionar un carcter. Se anular el proceso.', mtWarning, [mbok], 0)
      else
      begin
        tabla.SaveToText(dlguardar.filename, true, #9, separador, separador);
        MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
      end;
    end;
  end;
end;

procedure TformPalet.actEnviarTodosXMLExecute(Sender: TObject);
begin
  if tc.RecordCount <= 0 then
    MessageDlg ('No hay datos para exportar.', mtWarning, [mbok], 0)
  else
  begin
    dlguardar.Filter := 'Ficheros XML (*.xml)|*.xml|Todos los ficheros|*.*';
    dlguardar.Title := 'Exportar ' + ventanas + ' a XML';
    dlGuardar.DefaultExt := 'xml';
    dlguardar.FileName := ventanas;
    if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
      createdir (extractfilepath(application.ExeName) + 'Exportados');
    dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
    if dlGuardar.execute then
    begin
      tabla.SaveToXML(dlguardar.FileName,true);
      MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
    end;
  end;
end;

procedure TformPalet.actMostrarOcultarAutofiltrosExecute(
  Sender: TObject);
begin
  tabla.Filter.Active := not tabla.Filter.Active;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
end;

procedure TformPalet.actMostrarOcultarPanelAgrupacionExecute(
  Sender: TObject);
begin
  tabla.ShowGroupPanel := not tabla.ShowGroupPanel;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
end;

procedure TformPalet.actMostrarOcultarSumarioExecute(Sender: TObject);
begin
  tabla.ShowSummaryFooter := not tabla.ShowSummaryFooter;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
end;

procedure TformPalet.TablaMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button <> mbRight) or (Shift <> []) then
    Exit;
  TdxDBGridPopupMenuManager.Instance.ShowGridPopupMenu(Sender as TdxDBGrid);
end;

procedure TformPalet.FormCreate(Sender: TObject);
begin
  tTabla := datos.tPalet;
  llenarGrid();
end;

end.
