unit UnidadReorganizar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, ExtCtrls, dbtables, bde, db, FileCtrl;

type
  TFormReorganizar = class(TForm)
    OpCompactar: TCheckBox;
    PCompactar: TProgressBar;
    Panel1: TPanel;
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    TTabla: TTable;
    OpReindexar: TCheckBox;
    PReindexar: TProgressBar;
    lstFicheros: TFileListBox;
    LFichero: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BAceptarClick(Sender: TObject);
    procedure BCancelarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormReorganizar: TFormReorganizar;

  procedure Compactar (const ADatabase, ATable:String);
  procedure Reindexar (Tabla : ttable);

implementation

uses UnidadMenuPrincipal;


{$R *.DFM}

procedure TFormReorganizar.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  screen.Cursor := crdefault;
  action := cafree;
end;

procedure Reindexar (Tabla : ttable);
begin
  Check (dbiregenindexes (tabla.Handle));
end;

procedure Compactar (const ADatabase, ATable:String);
var
  ADB:TDataBase;
  SaveKC:Boolean;
  PdxStruct: CRTblDesc;
begin
  with TTable.Create(nil) do
  try
    close;
    DataBaseName := ADataBase;
    TableName := ATable;
    Exclusive := True;
    Open;
    ADB := DataBase;
    SaveKC := ADB.KeepConnection;
    ADB.KeepConnection:=True;
    try
      Close;
      FillChar(PdxStruct,SizeOf(PdxStruct),0);
      StrPCopy(PdxStruct.szTblName,ATable);
      PdxStruct.bPack:=True;
      Check(DbiDoRestructure(ADB.Handle,1,@PdxStruct,nil,nil,nil,False));
    finally
      ADB.KeepConnection:=SaveKC;
    end;
  finally
    Free;
  end;
end;

procedure TFormReorganizar.BAceptarClick(Sender: TObject);
var
  ruta : string;
  i : integer;
begin
{  codigoEmpresa := FormMenuPrincipal.leEntINI('Empresa', 'Codigo', 35000);
  if codigoEmpresa <> 35000 then
  begin
    if FormMenuPrincipal.vtServidor = 1 then
      ruta := extractfilepath(application.exename) + 'Emp' + inttostr(codigoEmpresa)
    else
      ruta := FormMenuPrincipal.vtrutaservidor + 'Emp' + inttostr(codigoEmpresa);}
    ruta := ExtractFilePath(ParamStr(0)) + 'Tablas';
    lstFicheros.Directory := ruta;
    if lstFicheros.Count > 0 then
    begin
      PCompactar.Max := lstFicheros.Count;
      PCompactar.Min := 0;
      PReindexar.Max := lstFicheros.Count;
      PReindexar.Min := 0;
      PCompactar.Visible := OpCompactar.Checked;
      PReindexar.Visible := OpReindexar.Checked;
      if OpCompactar.Checked then
      begin
        for i := 0 to lstFicheros.Count do
        begin
          lstFicheros.ItemIndex := i;
          LFichero.Caption := 'Compactando ' + extractfilename(lstFicheros.FileName);
          PCompactar.Position := i;
          compactar ('Trazabilidad',  extractfilename(lstFicheros.FileName));
          Refresh;
        end;
      end;
      if OpReindexar.Checked then
      begin
        for i := 0 to lstFicheros.Count do
        begin
          if OpReindexar.Checked then
          begin
            PReindexar.Position := i;
            LFichero.Caption := 'Compactando ' + extractfilename(lstFicheros.FileName);
            TTabla.Close;
            TTabla.DatabaseName := 'Trazabilidad';
            TTabla.exclusive := true;
            TTabla.TableName := extractfilename(lstFicheros.FileName);
            TTabla.open;
            reindexar (ttabla);
            Refresh;
          end;
        end;
      end;
    //end;
  end;
  messagedlg ('Proceso finalizado correctamente.', mtinformation, [mbok], 0);
  close;
end;

procedure TFormReorganizar.BCancelarClick(Sender: TObject);
begin
  close;
end;

end.
