unit UnidadSeleccion;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ToolWin, Grids, DBGrids, Db, DBTables,
  ActnList, Menus,variants;

type
  TFormSeleccion = class(TForm)
    Tabla: TDBGrid;
    Panel1: TPanel;
    TC: TQuery;
    DC: TDataSource;
    ActionList1: TActionList;
    ActSeleccionar: TAction;
    ActCerrar: TAction;
    TxtBuscar: TEdit;
    LB: TLabel;
    GroupBox1: TGroupBox;
    Op1: TRadioButton;
    Op2: TRadioButton;
    Op3: TRadioButton;
    Op4: TRadioButton;
    PopupMenu1: TPopupMenu;
    Seleccionar1: TMenuItem;
    Salir1: TMenuItem;
    N1: TMenuItem;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActNuevo: TAction;
    ActRefrescar: TAction;
    Nuevo1: TMenuItem;
    Refrescar1: TMenuItem;
    actMostrarTodos: TAction;
    ToolButton4: TToolButton;
    Mostrartodos1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);

    procedure seleccionar ();
    procedure ActCerrarExecute(Sender: TObject);
    procedure TxtBuscarChange(Sender: TObject);
    procedure TxtBuscarKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TxtBuscarKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActSeleccionarExecute(Sender: TObject);
    procedure actMostrarTodosExecute(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormSeleccion: TFormSeleccion;

implementation

uses UnidadMenuPrincipal, UnidadProcedimientos, UnidadGAgricultor, UnidadGParcela,
  UnidadModuloDatos, UnidadGCultivo, UnidadGProducto, UnidadGDistribuidor,
  UnidadGFabricante, UnidadGFormulacion, UnidadGCliente,
  UnidadGEntradaAlmacen;

{$R *.DFM}

procedure TFormSeleccion.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  tc.close;
  screen.cursor := crdefault;
  action := cafree;
end;

procedure TFormSeleccion.TablaKeyPress(Sender: TObject; var Key: Char);
begin
  if (key = 'c') or (key = 'C') or (key = chr(13))then
    actseleccionarexecute(nil);
end;

procedure TFormSeleccion.FormShow(Sender: TObject);
begin
  TC.Close;
  vtclaveelegida := '';
  ActRefrescarexecute(nil);
  txtbuscar.setfocus;
end;

procedure tformseleccion.seleccionar ();
begin
  if (tag in [vtNumCultivo, vtNumCliente, vtNumParcela, vtNumAgricultor,
      vtNumProducto, vtNumFabricante, vtNumDistribuidor, vtNumFormulacion,
      vtNumEntradaAlmacen, vtNumFichaControl]) then
  begin
    if not varisnull(tc.fieldbyname('Codigo').value) then
      vtClaveElegida := tc.fieldbyname('Codigo').value
  end;
  close;
end;

procedure TFormSeleccion.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TFormSeleccion.TxtBuscarChange(Sender: TObject);
begin
  if (tag in [vtNumCultivo, vtNumCliente, vtNumParcela, vtNumAgricultor,
      vtNumProducto, vtNumMateria, vtNumFabricante, vtNumDistribuidor,
      vtNumFormulacion]) then
  begin
    if Op1.Checked then //Nombre
    begin
      try
        tc.Locate ('Nombre', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
      except
        //silenciosa
      end;
    end;
    if Op2.Checked then //codigo
    begin
      try
        tc.Locate ('Codigo', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
      except
        //silenciosa
      end;
    end;
  end;

  if (tag = vtNumFichaControl) then //Ficha de control
  begin
    if Op1.Checked then  //Cultivo
      tc.Locate ('Cultivo', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
    if Op2.Checked then  //cdigo
      tc.Locate ('Codigo', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
    if Op3.Checked then  //agricultor
      tc.Locate ('Agricultor', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
  end;

  if (tag = vtNumEntradaAlmacen) then //entrada almacn
  begin
    if Op1.Checked then  //Cdigo
      tc.Locate ('Codigo', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
    if Op2.Checked then  //parcela
      tc.Locate ('Parcela', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
  end;
end;

procedure TFormSeleccion.TxtBuscarKeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then
  begin
    key := #0;
    tabla.setfocus;
  end;
end;

procedure TFormSeleccion.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TFormSeleccion.TxtBuscarKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 40 then  //tecla cursor abajo
    tabla.setfocus;
end;

procedure TFormSeleccion.ActNuevoExecute(Sender: TObject);
begin
  if tag = vtNumCultivo then //cultivo
  begin
    if comprobarPermisos ('altas', vtTipoUsuario, vtTablaCultivo) then
    begin
      vtAccion := 'nuevo';
      application.createform(tformGCultivo, formGCultivo);
      formGCultivo.ShowModal;
    end;
  end;

  if tag = vtNumAgricultor then //Agricultor
  begin
    if comprobarPermisos ('altas', vtTipoUsuario, vtTablaAgricultor) then
    begin
      vtAccion := 'nuevo';
      application.createform(tformGAgricultor, formGAgricultor);
      formGAgricultor.ShowModal;
    end;
  end;

  if tag = vtNumParcela then //parcela
  begin
    if comprobarPermisos ('altas', vtTipoUsuario, vtTablaParcela) then
    begin
      vtAccion := 'nuevo';
      application.createform(tformGParcela, formGParcela);
      formGParcela.ShowModal;
    end;
  end;

  if tag = vtNumProducto then //producto
  begin
    if comprobarPermisos ('altas', vtTipoUsuario, vtTablaProducto) then
    begin
      vtAccion := 'nuevo';
      application.createform(tFormProductoG, FormProductoG);
      FormProductoG.ShowModal;
    end;
  end;

  if tag = vtNumDistribuidor then //distribuidor
  begin
    if comprobarPermisos ('altas', vtTipoUsuario, vtTablaDistribuidor) then
    begin
      vtAccion := 'nuevo';
      application.createform(tformGDistribuidor, formGDistribuidor);
      formGDistribuidor.ShowModal;
    end;
  end;
                       
  if tag = vtNumFormulacion then //formulacin
  begin
    if comprobarPermisos ('altas', vtTipoUsuario, vtTablaFormulacion) then
    begin
      vtAccion := 'nuevo';
      application.createform(tformGFormulacion, formGFormulacion);
      formGFormulacion.ShowModal;
    end;
  end;

  if tag = vtNumFabricante then //fabricante
  begin
    if comprobarPermisos ('altas', vtTipoUsuario, vtTablaFabricante) then
    begin
      vtAccion := 'nuevo';
      application.createform(tformGFabricante, formGFabricante);
      formGFabricante.ShowModal;
    end;
  end;

  if tag = vtNumCliente then //Cliente
  begin
    if comprobarPermisos ('altas', vtTipoUsuario, vtTablaCliente) then
    begin
      vtAccion := 'nuevo';
      application.createform(tformGCliente, formGCliente);
      formGCliente.ShowModal;
    end;
  end;

  if tag = vtNumEntradaAlmacen then //Entrada almacn
  begin
    if comprobarPermisos ('altas', vtTipoUsuario, vtTablaEntradaAlmacen) then
    begin
      vtAccion := 'nuevo';
      application.createform(tformGEntradaAlmacen, formGEntradaAlmacen);
      formGEntradaAlmacen.ShowModal;
    end;
  end;
                                                
  ActRefrescarExecute(nil);
end;

procedure TFormSeleccion.ActRefrescarExecute(Sender: TObject);
begin
  tc.close;
  tc.sql.clear;
  if tag = vtnumCultivo then //cultivo
  begin
    Caption := 'Seleccin de cultivo...';
    tc.sql.add('SELECT Codigo, Nombre');
    tc.sql.add('FROM ' + vtTablaCultivo);
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by nombre');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by codigo');
    end;
  end;

  if tag = vtNumProducto then //producto
  begin
    Caption := 'Seleccin de producto...';
    tc.sql.add('SELECT Codigo, Nombre');
    tc.sql.add('FROM ' + vtTablaProducto);
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by nombre');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by codigo');
    end;
  end;

  if tag = vtNumAgricultor then //Agricultor
  begin
    Caption := 'Seleccin de agricultor...';
    tc.sql.add('SELECT Codigo, Nombre');
    tc.sql.add('FROM ' + vtTablaAgricultor);
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by nombre');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by codigo');
    end;
  end;

  if tag = vtNumParcela then //parcela
  begin
    Caption := 'Seleccin de parcela...';
    tc.sql.add('SELECT Codigo, Nombre');
    tc.sql.add('FROM ' + vtTablaParcela);
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by nombre');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by codigo');
    end;
  end;

  if tag = vtNumFabricante then //fabricante
  begin
    Caption := 'Seleccin de fabricante...';
    tc.sql.add('SELECT Codigo, Nombre');
    tc.sql.add('FROM ' + vtTablaFabricante);
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by nombre');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by codigo');
    end;
  end;

  if tag = vtNumDistribuidor then //distribuidor
  begin
    Caption := 'Seleccin de distribuidor...';
    tc.sql.add('SELECT Codigo, Nombre');
    tc.sql.add('FROM ' + vtTablaDistribuidor);
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by nombre');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by codigo');
    end;
  end;

  if tag = vtNumFormulacion then //formulacion
  begin
    Caption := 'Seleccin de formulacin...';
    tc.sql.add('SELECT Codigo, Nombre');
    tc.sql.add('FROM ' + vtTablaFormulacion);
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by nombre');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by codigo');
    end;
  end;


  if tag = vtNumCliente then //cliente
  begin
    Caption := 'Seleccin de cliente...';
    tc.sql.add('SELECT Codigo, Nombre');
    tc.sql.add('FROM ' + vtTablaCliente);
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by nombre');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by codigo');
    end;
  end;

  if tag = vtNumEntradaAlmacen then //Entrada almacn
  begin
    Caption := 'Seleccin de Entrada de Almacn...';
    tc.SQL.Add('SELECT ea.Codigo, ea.Fecha, ea.Hora, pc.Nombre Parcela, ea.Matricula');
    tc.SQL.Add('FROM ' + vtTablaEntradaAlmacen + ' ea, ' + vtTablaParcela + ' pc');
    tc.SQL.Add('WHERE ea.CodigoParcela = pc.Codigo');
    if vtEntradasAlmacenNoFinalizadas then
    begin
      tc.SQL.Add('AND ea.Finalizada = :pFinalizada');
      TC.ParamByName('pFinalizada').DataType := ftBoolean;      
      TC.ParamByName('pFinalizada').Value := False;
    end;
    op1.visible := true;
    op2.visible := true;
    op1.caption := 'Cdigo';
    op2.caption := 'Parcela';
    if Op1.Checked then  //cdigo
    begin
      tc.sql.add('Order by ea.Codigo');
      lb.Caption := '&Buscar por cdigo';
    end;
    if Op2.Checked then  //parcela
    begin
      lb.Caption := '&Buscar por Parcela';
      tc.sql.add('Order by Parcela');
    end;
  end;
      
  if tag = vtNumFichaControl then //Ficha de control
  begin
    Caption := 'Seleccin de Factura Emitida...';
    //FALTA SELECT PARA MOSTRAR
    
    op1.visible := true;
    op2.visible := true;
    op3.visible := true;
    op1.caption := '&N';
    op2.caption := 'Cdig&o';
    op3.Caption := 'Almacenista';
    if Op1.Checked then  //nmero
    begin
      tc.sql.add('Order by fac.NumeroFactura');
      lb.Caption := '&Buscar por n';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by fac.Codigo');
    end;
    if Op3.Checked then  //Almacenista
    begin
      lb.Caption := '&Buscar por Almacenista';
      tc.sql.add('Order by ter.Nombre');
    end;
  end;    

  try
    tc.open;
  except
    raise;
  end;
  tc.FieldByName('Codigo').DisplayLabel := 'Cdigo';
  tc.FieldByName('Codigo').DisplayWidth := 6;
{  if (tag = 50) or (tag = 55) then //productos
  begin
    tc.FieldByName('Codigo').DisplayWidth := 7;
    tc.FieldByName('Nombre').DisplayWidth := 35;
    tc.FieldByName('Distribuidor').DisplayWidth := 15;
    tc.FieldByName('Fabricante').DisplayWidth := 15;
    tc.FieldByName('Unidad').DisplayWidth := 3;
  end;}
  txtbuscar.setfocus;
end;

procedure TFormSeleccion.ActSeleccionarExecute(Sender: TObject);
begin
  seleccionar();
end;

procedure TFormSeleccion.actMostrarTodosExecute(Sender: TObject);
begin
  tag := 50;
  ActRefrescarExecute(nil);
end;

end.
